EXPLut:
	.dw 10,13,16,20,24,31,38,48,60,75,93,116,146,182,227,284,355,444,555,694,867,1084,1355,1694,2118,2647,3309,4136,5170,6462,8078,10097,12622,15777,19722,24652,30815,48148,60185
; input: a - enemy
; returns a==0: continue, a==1: dead
BattleEngine:
	;xor a
	;ret
	
	ld h,0
	ld l,a
	ld b,14
	call Multiply
	ld de,enemies
	add hl,de
	ld de,enemy
	ld bc,14 ; if changing also change in battle instructions!
	ldir
	
	bcall(_RevUpdate)
	
	ld b,2
	-:
		push bc
			bcall(_ClrFrontBuffers)
			bcall(_Sleep_short)
			bcall(_Update)
			bcall(_Sleep_short)
		pop bc
		djnz {-}
	
	ld b,32
	ld ix,frontBuffer1 + (12*64)
	ld iy,frontBuffer2 + (12*64)
	-:
		push bc
			dec b
			xor a
			ld b,24
			--:
				dec ix
				dec iy
				ld (ix),a
				ld (iy),a
				djnz {--}
			bcall(_Sleep_veryshort)
		pop bc
		djnz {-}
	
		
	ld a,(enemy_lvl)
	ld b,a
	and $f0
	xor $f0
	jr nz,{+}
		; ok, we need to determin the lvl based on reubens
		ld a,b
		and $0f
		ld b,a
		call random
		ld b,a
		ld a,(reuben_lvl)
		sub b
		
		sub 2 ; trying out to have auto-leveling being....easier
		
		jr z,{++}
		jr c,{++}
		ld (enemy_lvl),a
		jr {+}
	++:
		ld a,1
		ld (enemy_lvl),a
	+:
	ld de,(enemy_hp)
	inc d
	jr nz,{+}
		; ok we need to determin the HP based on Reubens
		; d is already zero
		ld bc,(reuben_maxhp)
		call BC_Div_DE_round
		ld (enemy_hp),bc
	+:
	
	ld hl,battle_flags
	set 1,(hl)
	bit 0,(hl)
	jr nz,{++} ; no automatic re-leveling for maru
		ld a,(enemy_lvl)
		ld c,a
		ld a,(reuben_lvl)
		sub 6 ; we want some spacing
		jr c,{++}
		sub c
		jr c,{++}
		; ok, time to re-level the enemy!
		add a,5 ; in a is now the difference between reuben lvl and enemy lvl (minus one)
		ld b,a
		call random
		add a,c
		ld (enemy_lvl),a
	+:
		ld a,(reuben_wait)
		add a,30
		jr c,{+}
		
		ld c,a
		ld a,(enemy_wait)
		ld d,a
		sub c
		jr c,{+}
		
		add a,30 ; in a is now the difference between reuben speed and enemy speed
		
		ld b,a
		call random
		ld b,a
		ld a,d
		sub b
		ld (enemy_wait),a
	+:
	++:
	xor a
	ld (battlePoison),a      ; make sure you aren't poisend by default
	ld (battleReubenState),a ; and that we wait
	ld (battleStunCounter),a
	ld (battleEnemyStun),a
	
	;ld a,(reuben_wait) ; let's randomize the initial wait-times
	;ld b,a
	;call random
	ld (battleReubCurWait),a
	
	ld a,(enemy_wait)
	ld b,a
	call random
	ld (battleEnemyCurWait),a
	
	
	call _Battle_Draw
	
	call _Battle_Loop
	
	ld hl,battle_flags
	res 1,(hl)
	
	bcall(_Update) ; we want to erase any extra stuff
	
	call _Battle_Status ; we want to know what is going on
	cp 3  ; we just ran away
	jp z,_BattleEnd_player_run
	
	dec a ; offset stuff correctly
	jp nz,_BattleEnd_player_dead ; we died :(

	; player actually won, now check for leveling up etc
	ld hl,battle_flags
	bit 0,(hl)
	jp nz,_BattleEnd_player_win ; no leveling / gold for maru
	
	ld b,2
	call random
	ld l,a
	ld h,0
	bcall(_Reuben_add_Gold)
	
	isEvent_real(event_item_bomb_offset,event_item_bomb_bit)
	jr z,{+}
	ld b,50
	call random
	or a
	jr nz,{+}
	ld d,1
	bcall(_Reuben_add_Bombs)
	+:
	
	ld a,(reuben_lvl)
	cp 41 ; max level, else var overflow
	jp z,_BattleEnd_player_win
	
	ld hl,(reuben_exp)
	ld de,(enemy_exp)
	add hl,de           ; this will also reset the carry for sbc
	ld (reuben_exp),hl
	
	
	xor a
	ld de,(reuben_nextexp)
	sbc hl,de
	jp c,_BattleEnd_player_win
	
	; ok we need to level up
	ld (reuben_exp),hl ; we now have the overflow saved!
	
	call BigTextCont
	.dw $2B14
	.dw string_level_up
	.db $ff
	
	ld d,5
	
	ld a,(reuben_maxmp)
	add a,d
	ld (reuben_maxmp),a
	ld a,(reuben_mp)
	add a,d
	ld (reuben_mp),a
	
	ld hl,(reuben_lvl) ; calculate next max HP!
	ld h,0
	ld b,l
	call Multiply
	ld b,10
	call Multiply
	ld de,120
	add hl,de
	push hl
		ld de,(reuben_maxhp)
		sbc hl,de
		ex de,hl
	pop hl
	ld (reuben_maxhp),hl
	
	ld hl,(reuben_hp)
	add hl,de
	ld (reuben_hp),hl
	
	ld a,(reuben_lvl)
	add a,a
	ld h,0
	ld l,a
	ld de,EXPLut-2 ; minus two as we store level=1 but we need 0
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld (reuben_nextexp),de
	ld hl,reuben_lvl
	inc (hl)
	call _BattleEnd_player_win ; we want it to pause afterward a bit more
	bcall(_Sleep_medlong)
	xor a
	ret
_BattleEnd_player_run:
	; first we delete reuben
;	call PutBigSpriteXOR_backbuffer
;	.dw getCoordinates(70,35)
;	.db bigsprite_reuben
	ld de,9
	ld c,96-70
	-:
		ld ix,frontBuffer1 + (35*12) + 8
		ld hl,frontBuffer2 + (35*12) + 8
		ld b,16
		--:
			sra (ix)
			inc ix
			rr (ix)
			inc ix
			rr (ix)
			inc ix
			rr (ix)
			sra (hl)
			inc hl
			rr (hl)
			inc hl
			rr (hl)
			inc hl
			rr (hl)
			add ix,de
			add hl,de
			djnz {--}
		bcall(_Sleep_short)
		dec c
		jr nz,{-}
	xor a
	ret
_BattleEnd_player_win:
	ld ix,frontBuffer2
	ld iy,frontBuffer1
	call _Battle_Draw_Enemy_no_buffer
	
	bcall(_Sleep_medlong)
	ld ix,frontBuffer1
	ld iy,frontBuffer1
	call _Battle_Draw_Enemy_no_buffer
	
	bcall(_Sleep_medlong)
	ld ix,frontBuffer2
	ld iy,frontBuffer2
	call _Battle_Draw_Enemy_no_buffer
	
	xor a
	ret
_BattleEnd_player_dead:
	call BigTextCont
	.dw $4214
	.dw string_fatal
	.db $ff
-:
	ld ix,frontBuffer1
	ld b,2
	call random
	or a
	jr z,{+}
	ld ix,frontBuffer2
+:
	ld b,16
	call random
	ld c,35
	add a,c
	ld c,a
	
	ld b,16
	call random
	ld b,70
	add a,b
	ld b,a
	
	ld e,1
	push bc
	push ix
		bcall(_drawPxlOR)
	pop ix
	pop bc
	call drawPxlXOR
	ld b,100
	--:
		ex (sp),hl
		ex (sp),hl
		djnz {--}
	in a,(1)
	inc a
	jr z,{-}
	
	ld a,1
	ret


_Battle_Loop:
	in a,(1)
	ld b,a
	bit 6,b
	jr nz,{+}
		call Inventory
		ld b,$ff
	+:
	
	bcall(_Sleep_veryshort)
	
	ld a,(battleStunCounter)
	or a
	jr z,_Battle_loop_reuben_no_stun
		ld hl,battleStunCounter
		dec (hl)
		ld a,(hl)
		or a
		call z,_Battle_Redraw_frontbuffer
		jr _Battle_loop_reuben_done
	_Battle_loop_reuben_no_stun:
	ld a,(battleReubenState)
	or a
	jr nz,_Battle_loop_reuben_no_progress
		ld hl,battleReubCurWait
		inc (hl)
		call _Battle_Update_Progressbar
		ld a,(battleReubCurWait)
		ld hl,reuben_wait
		xor (hl)
		jr nz,_Battle_loop_reuben_done
		
		; we are done progressing!
		ld a,1
		ld (battleReubenState),a
		
		
		call _Battle_Redraw_frontbuffer
		
		jr _Battle_loop_reuben_done
	_Battle_loop_reuben_no_progress:
	dec a
	jr nz,_Battle_loop_reuben_no_normalmenu
		bit 0,b
		jp z,_Battle_Player_Item
		
		bit 1,b
		jp z,_Battle_Player_Attack_Normal
		
		bit 2,b
		jp z,_Battle_Player_Run
		
		bit 3,b
		jr nz,{+}
			; time for maaagic!
			ld a,2
			ld (battleReubenState),a
			bcall(_Wait_Key_Release)
			call _Battle_Redraw_frontbuffer
			jr _Battle_loop_reuben_done
		+:
		
	_Battle_loop_reuben_no_normalmenu:
	dec a
	jr nz,_Battle_loop_reuben_done
		; magic menu!
		bit 0,b
		jp z,_Battle_Player_Magic_Fire
		
		bit 1,b
		jp z,_Battle_Player_Magic_Stun
		
		bit 2,b
		jp z,_Battle_Player_Magic_Bolt
		
		bit 3,b
		jp z,_Battle_Player_Magic_Ice
		
		bit 7,b
		jr nz,{+}
			inc a ; ld a,1
			ld (battleReubenState),a
			bcall(_Wait_Key_Release)
			call _Battle_Redraw_frontbuffer
		+:
	_Battle_loop_reuben_done:
	call _Battle_Status
	or a
	ret nz ; someone died or we ran away successfully
	
	; enemy stuff, no state as it is always the same
	ld a,(battleEnemyStun)
	or a
	jr z,_Battle_Loop_Enemy_no_stun
		ld hl,battleEnemyStun
		dec (hl)
		ld a,(hl)
		or a
		jr nz,_Battle_Loop_enemy_done
		; a is zero
		ld (battleEnemyCurWait),a
		call _Battle_Redraw_frontbuffer
		jr _Battle_Loop_enemy_done
	_Battle_Loop_Enemy_no_stun:
		ld hl,battleEnemyCurWait
		inc (hl)
		ld a,(hl)
		ld hl,enemy_wait
		xor (hl)
		jr nz,_Battle_Loop_enemy_done ; no need to check if we wanne attack
		ld b,25
		call random
		or a ; check if we actually wanne attack
		jp z,_Battle_Enemy_Do_Attack
		
		; we actually wait another loop
		ld hl,battleEnemyCurWait
		dec (hl)
	
	
	_Battle_Loop_enemy_done:
	
	
	ld a,(battlePoison)
	or a
	jr z,_Battle_Loop_no_poison
		ld hl,battlePoison
		dec (hl)
		ld a,(hl)
		cp 1
		call z,_Battle_Enemy_perform_poison
	_Battle_Loop_no_poison:
	call _Battle_Status
	or a
	ret nz ; someone died or we ran away successfully
	
	jp _Battle_Loop

_Battle_Player_Attack_And_Reset:
; b - attack type
	call _Battle_Player_Calc_Damage
	push hl
		ld bc,getCoordinates(52,16)
		xor a
		bcall(_NumText)
		
		
		bcall(_Sleep_long)
	pop hl

	call _Battle_Player_Subtract_Damage

_Battle_Player_Reset:
	; cleanup
	xor a
	ld (battleReubCurWait),a
	ld (battleReubenState),a
_Battle_Player_Reset_only_redraw:
	call _Battle_Draw_Progressbar_frame
	call _Battle_Redraw_frontbuffer


	jp _Battle_loop_reuben_done ; time to go here
_Battle_Player_Attack_Normal:
	call _Battle_Player_Attack_animation
	ld b,0 ; normal attack
	jp _Battle_Player_Attack_And_Reset

_Battle_Player_Attack_animation:

	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(58,39)
	.db bigsprite_reuben_sword_1
	bcall(_Update)
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(58,39)
	.db bigsprite_reuben_sword_1
	

	bcall(_Sleep_med)
	
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(56,44)
	.db bigsprite_reuben_sword_2
	bcall(_Update)
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(56,44)
	.db bigsprite_reuben_sword_2
	
	bcall(_Sleep_med)
	
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(60,45)
	.db bigsprite_reuben_sword_3
	bcall(_Update)
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(60,45)
	.db bigsprite_reuben_sword_3
	
	bcall(_Sleep_med)
	
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(15,39)
	.db bigsprite_swoosh
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(22,27)
	.db bigsprite_swoosh
	ret

_Battle_Player_Run:
	ld a,(enemy_sl5)
	bit 0,a
	jp z,_Battle_loop_reuben_done ; you can't run from boss fights!
	ld a,(battle_flags)
	bit 0,a
	jp nz,_Battle_loop_reuben_done ; no running from maru!
	; cleanup
	xor a
	ld (battleReubCurWait),a
	ld (battleReubenState),a
	call _Battle_Draw_Progressbar_frame
	call _Battle_Redraw_frontbuffer
	
	ld b,2
	call random
	or a
	jp z,_Battle_loop_reuben_done
	ld hl,$ffff
	ld (enemy_hp),hl
	jp _Battle_loop_reuben_done

_Battle_Player_Item:
	ld a,(battle_flags)
	bit 0,a
	jp nz,_Battle_loop_reuben_done ; no items with maru!
	ld a,(reuben_curitem)
	or a
	jr z,_Battle_Player_Item_exit
	cp item_bottle4+1
	jp c,_Battle_Player_Item_Bottle
	cp item_bomb
	jr z,_Battle_Player_Item_Bomb
_Battle_Player_Item_exit:
	jp _Battle_loop_reuben_done ; time to go here

_Battle_Player_Item_Bomb:
	ld a,(reuben_bombs)
	or a
	jr z,_Battle_Player_Item_exit ; we don't have any bombs
	
	ld hl,reuben_bombs
	dec (hl)
	
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(60,19)
	.db bigsprite_bomb_frame_1
	bcall(_Sleep_medmedlong)
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(44,13)
	.db bigsprite_bomb_frame_2
	bcall(_Sleep_medmedlong)
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(32,15)
	.db bigsprite_bomb_frame_3
	bcall(_Sleep_medmedlong)
	
	ld b,$07
	call _Battle_Fire_Animation
	
	ld b,4
	jp _Battle_Player_Attack_And_Reset

_Battle_use_mp_5:
	ld b,5
_Battle_use_mp:
; takes b
; returns c if not enough MP
	ld a,(reuben_mp)
	sub b
	ret c
	ld (reuben_mp),a
	ret
_Battle_Player_Magic_Stun:
	ld b,10
	call _Battle_use_mp
	jp c,_Battle_loop_reuben_done
	bcall(_Update)
	call _Battle_Reuben_Jump
	
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(68,19)
	.db bigsprite_stun
	bcall(_Sleep_medmedlong)
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(52,13)
	.db bigsprite_stun
	bcall(_Sleep_medmedlong)
	bcall(_Update)
	
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(40,15)
	.db bigsprite_stun
	bcall(_Sleep_medmedlong)
	
	ld a,$ff
	ld (battleEnemyStun),a
	
	ld a,1
	ld (battleReubenState),a
	jp _Battle_Player_Reset_only_redraw
_Battle_Player_Magic_Fire:
	call _Battle_use_mp_5
	jp c,_Battle_loop_reuben_done
	bcall(_Update)
	call _Battle_Reuben_Jump
	ld b,7
	call _Battle_Fire_Animation
	
	ld b,1
	jp _Battle_Player_Attack_And_Reset
_Battle_Ice_Sprite:
	.db $00,$00,$0f,$03,$00,$7C,$F0,$C0,$00,$00,$0f,$03,$00,$7C,$F0,$C0
_Battle_Player_Magic_Ice:
	call _Battle_use_mp_5
	jp c,_Battle_loop_reuben_done
	bcall(_Update)
	call _Battle_Reuben_Jump
	
	ld de,16*12
	ld b,8
	-:
		ld c,8
		--:
			push bc
			push de
				ld hl,_Battle_Ice_Sprite
				ld ix,frontBuffer1
				ld iy,frontBuffer2
				bcall(_graySpriteOverwritealigned)
			pop de
			pop bc
			inc de
			dec c
			jr nz,{--}
		push de
		push bc
			call XORScreen
			bcall(_Sleep_short)
			call XORScreen
			bcall(_Sleep_short)
		pop bc
		pop hl
		ld de,4+(7*12)
		add hl,de
		ex de,hl
		djnz {-}
	
	ld b,10
	-:
		push bc
			call XORScreen
			bcall(_Sleep_short)
		pop bc
		djnz {-}
	bcall(_Update)
	ld b,2
	jp _Battle_Player_Attack_And_Reset
_Battle_Player_Magic_Bolt:
	call _Battle_use_mp_5
	jp c,_Battle_loop_reuben_done
	bcall(_Update)
	call _Battle_Reuben_Jump
	ld b,19
	call _Battle_Bolt_Animation
	ld b,3
	jp _Battle_Player_Attack_And_Reset

_Battle_Player_Inc_HP:
; requires hl
	push hl
		bcall(_Reuben_add_HP)
		
		bcall(_Update)
		
		call BigTextCont
		.dw getCoordinates(64,20)
		.dw string_plusSign
		.db $ff
	pop hl
	xor a
	bcall(_NumText) ; hl is already set
	
	bcall(Sleep_long)
	ret

_Battle_Player_Inc_MP:
	push de
		call Reuben_add_MP
		
		bcall(_Update)
		
		call BigTextCont
		.dw getCoordinates(60,20)
		.dw string_plusSign
		.db $ff
	pop de
	ld h,0
	ld l,d
	bcall(_NumText)
	call BigTextCont
	.db $fe
	.dw string_MP
	.db $ff
	jp Sleep_long

_Battle_Reuben_Blink:
	bcall(_Update)
	ld b,10
	@:
	push bc
		call PutBigSpriteXOR_frontbuffer
		.dw getCoordinates(70,35)
		.db bigsprite_reuben
		
		bcall(_Sleep_short)
		bcall(_Update)
		bcall(_Sleep_short)
	pop bc
	djnz {-1@}
	ret

_Battle_Player_Calc_Damage:
; calculates damage into hl
;INPUT: b=type (0 - normal, 1 - fire, 2 - ice, 3 - bolt, 4 - bomb)
;round(W*(2+randInt(0,10R)+R^2)/(2E),0)
	push bc ; reuben_sword
		ld hl,(reuben_lvl) ; enemy_lvl times itself into hl
		ld h,0 ; little endian trick thingy
		ld b,l
		call Multiply
		add hl,hl      ; new we have 2R^2
		push hl
			ld hl,(reuben_lvl)
			ld h,0
			ld b,10
			call Multiply
			ld b,l
			call random
			add a,2
			ld e,a
			ld d,h ; in case that did overflow 8 bits we at least still give some damage
		pop hl
		add hl,de
		
		ld a,(reuben_sword)
		ld b,a
		call Multiply
		 ; now we have the nominator
		
		ld b,h
		ld c,l
		
		ld de,(enemy_lvl)  ; e * 2
		ld d,0
		ld h,0
		ld l,e
		add hl,de
		ex de,hl
		
		call BC_Div_DE_round
		
		ld h,b
		ld l,c
	pop af ; we want to ld a,b anyways and this does it for us
	
	; calculte weakness and immunity
	or a
	ret z
	
	push hl
		
		ld hl,enemy_sl1-1 ; load slot and add offset, value resulting in b
		ld d,0
		ld e,a
		add hl,de
		ld a,(hl)
		and $0F ; we only want the defense!
		ld b,a
	
	pop hl
	jp Multiply ; multiply by weakness indicator

_Battle_Player_Subtract_Damage: ; subtract damage from enemy
	ex de,hl
	ld hl,(enemy_hp)
	xor a ; make sure carry is 0
	sbc hl,de
	jr nc,{+1@}
		ld hl,0
	@:
	ld (enemy_hp),hl
	ret


_Battle_Enemy_Do_Attack:
	; xor a ; no need as a is always 0 if we call this (called if rand returns 0)
	ld (battleEnemyCurWait),a ; make sure we wait again
	
	call _Battle_Enemy_Blink
_Battle_Enemy_Do_Attack_no_blink_or_wait:
	
	ld hl,enemy_sl1 ; get attack slot
	ld b,5
	call random
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	and $F0
	cp $00
	jr z,_Battle_Enemy_Normal_Attack
	cp $10
	jr z,_Battle_Enemy_Fire_Attack
	cp $20
	jp z,_Battle_Enemy_Bolt_Attack
	cp $30
	jp z,_Battle_Enemy_Poison_Attack
	cp $40
	jp z,_Battle_Enemy_Stun_Attack
	jr _Battle_Enemy_Normal_Attack ; if we don't know what to do then do a normal attack

_Battle_Enemy_Normal_Attack:
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(67,39)
	.db bigsprite_swoosh
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(75,26)
	.db bigsprite_swoosh
	
	
	call _Battle_Enemy_Calc_Damage
	push hl
		call _Battle_Enemy_Subtract_Damage
	pop hl
	
	ld bc,getCoordinates(60,20) ; display damage
	xor a
	bcall(_NumText)
	
	call _Battle_Shake_Screen
	
	bcall(_Sleep_long)
	call _Battle_Redraw_frontbuffer
	
	jp _Battle_Loop_enemy_done
_Battle_Enemy_Fire_Attack:
	
	ld b,$3C
	call _Battle_Fire_Animation
	call _Battle_Enemy_Calc_Damage
	add hl,hl
	push hl
		call _Battle_Enemy_Subtract_Damage
	pop hl
	
	ld bc,getCoordinates(60,20)             ; display damage
	xor a
	bcall(_NumText)
	bcall(_Sleep_long)
	
	call _Battle_Redraw_frontbuffer
	
	jp _Battle_Loop_enemy_done
_Battle_Enemy_Bolt_Attack:
	
	ld b,$4B
	call _Battle_Bolt_Animation
	
	call _Battle_Enemy_Calc_Damage
	add hl,hl
	add hl,hl
	push hl
		call _Battle_Enemy_Subtract_Damage
	pop hl
	
	ld bc,getCoordinates(57,20)             ; display damage
	xor a
	bcall(_NumText)
	bcall(_Sleep_long)
	
	
	call _Battle_Redraw_frontbuffer
	
	jp _Battle_Loop_enemy_done
_Battle_Enemy_Poison_Attack:
	ld a,(battlePoison)
	cp 2
	jr z,_Battle_Enemy_Normal_Attack ; we were already poisoned so let's do a normal attack instead
	
	ld a,2
	ld (battlePoison),a
	
	call _Battle_Redraw_frontbuffer
	
	jp _Battle_Loop_enemy_done
_Battle_Enemy_perform_poison:
	bcall(_Update)
	call _Battle_Display_poison
	ld a,(enemy_wait)
	ld (battlePoison),a
	ld hl,(enemy_lvl)
	ld h,0
	add hl,hl
	push hl
		call _Battle_Enemy_Subtract_Damage
	pop hl
	ld bc,getCoordinates(70,20)
	xor a
	bcall(_NumText)
	bcall(_Sleep_long)
	
	jp _Battle_Redraw_frontbuffer
	
_Battle_Enemy_Stun_Attack:
	ld a,(battleStunCounter)
	or a
	jp nz,_Battle_Enemy_Normal_Attack
	
	ld a,(enemy_wait)
	ld (battleStunCounter),a
	
	;call _Battle_Redraw_frontbuffer
	
	jp _Battle_Enemy_Do_Attack_no_blink_or_wait ; we actually perform a normal attack
_Battle_Enemy_Calc_Damage:
; calculates damage into hl
;INPUT: none
;round(5*(5+randInt(0,10E)+E^3)/(2R+4(randInt(0,A)+A)+A^2),0)
	
	; let's first calc the denominator
	ld a,(reuben_armor)
	or a
	jr z,{+1@} ; else random will return wrong stuff
		ld b,a
		call random
	@:
	ld l,a
	ld h,0
	ld de,(reuben_armor)
	ld d,0
	add hl,de
	
	ld a,4
	call HL_times_A
	
	push hl
		ld hl,(reuben_armor)
		ld h,0
		ld a,l
		call HL_times_A
	pop de
	add hl,de
	push hl
		ld hl,(reuben_lvl)
		ld h,0
		ld d,0
		ld e,l
		add hl,de
	pop de
	add hl,de
	; now we have the denominator in hl
	push hl
		ld de,(enemy_lvl)
		ld d,0
		ld a,10
		call DE_times_A
		ld b,l
		call random
		add a,5
		ld l,a
		;ld h,h ; in case we did overflow 8 bit we at least add some damage
		push hl
			ld hl,(enemy_lvl)
			ld h,0
			ld b,l
			call Multiply
			ld a,(enemy_lvl)
			call HL_times_A
		pop de
		add hl,de
		; now we have the nominator in hl
		ld b,h
		ld c,l
	pop de
	
	call BC_Div_DE_round
	ld d,b
	ld e,c
	
	ld a,5
	jp DE_times_A
	; we now have the damage in HL!
	;ret ; tail-end

_Battle_Enemy_Subtract_Damage:
	
	ld d,h ; subtract damage from enemy
	ld e,l
	ld hl,(reuben_hp)
	xor a ; make sure carry is 0
	sbc hl,de
	jr nc,{+1@}
		ld hl,0
	@:
	ld (reuben_hp),hl
	ret



_Battle_Status:
; Returns in a the status of the battle
; 0:continue; 1:enemy dead; 2:player dead; 3:run´
	ld hl,(enemy_hp)
	ld de,$FFFF
	xor a
	sbc hl,de
	jr z,_Battle_Status_Run
	add hl,de
	xor a ; check if hl is empty
	or h
	or l
	jr z,_Battle_Status_Enemy_Dead
	ld hl,(reuben_hp)
	xor a
	or h
	or l
	jr z,_Battle_Status_Reuben_Dead
	xor a
	jr _Battle_Status_Continue
_Battle_Status_Run:
	inc a
_Battle_Status_Reuben_Dead:
	inc a
_Battle_Status_Enemy_Dead:
	inc a
_Battle_Status_Continue:
	ret

_Battle_Reuben_Jump:
	ld bc,getCoordinates(70,35)
	-:
		dec c
		ld a,bigsprite_reuben
		push bc
			call PutBigSpriteXOR_frontbuffer_dyn
		pop bc
		bcall(_Sleep_short)
		ld a,c
		cp 35-8
		jr nz,{-}
	-:
		ld a,bigsprite_reuben
		push bc
			call PutBigSpriteXOR_frontbuffer_dyn
		pop bc
		inc c
		bcall(_Sleep_short)
		ld a,c
		cp 35
		jr nz,{-}
	bcall(_Update)
	ret
_Battle_Draw:
	bcall(_ClrBackBuffers)
	
	bcall(_Battle_Backgrounds)
	
	ld ix,backBuffer1
	ld iy,backBuffer2
	call _Battle_Draw_Enemy_no_buffer
	
	; draw reuben
	call PutBigSpriteXOR_backbuffer
	.dw getCoordinates(70,35)
	.db bigsprite_reuben
	
	jp _Battle_Redraw_frontbuffer
_Battle_Draw_Enemy_no_buffer:
	ld a,(enemy_xpos)
	ld b,a
	ld a,(enemy_ypos)
	ld c,a
	ld a,(enemy_id)
	bcall(_PutBigSpriteXOR)
	ret

_Battle_Draw_Progressbar_frame:
	ld ix,frontBuffer1 + (25*12) + 7
	ld iy,frontBuffer2 + (25*12) + 7
	ld hl,$07FE
	ld b,3
	call drawHLineXOR
	ld ix,frontBuffer1 + (27*12) + 7
	ld iy,frontBuffer2 + (27*12) + 7
	ld hl,$07FE
	ld b,3
	call drawHLineXOR
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	ld bc,getCoordinates(60,26)
	ld e,0
	call drawPxlXOR
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	ld e,0
	ld bc,getCoordinates(95,26)
	call drawPxlXOR
	ret

_Battle_Progressbar_prepwork:
	ld b,34
	ld hl,(battleReubCurWait)
	ld h,0
	call Multiply
	ld b,h
	ld c,l
	
	ld de,(reuben_wait)
	ld d,0
	call BC_Div_DE_round
	xor a
	cp c
	ret z
	ld b,c
	ld de,getCoordinates(60,26)
	ret

_Battle_Update_Progressbar:
	call _Battle_Progressbar_prepwork
	ret z
	@:
		inc d
		djnz {-1@}
	ld b,d
	ld c,e
	ld e,1
	ld ix,frontBuffer1
	bcall(_drawPxlOR)
	ret

_Battle_Display_poison:
	call PutBigSpriteXOR_frontbuffer
	.dw getCoordinates(76,29)
	.db bigsprite_battle_poison
	ret
_Battle_Redraw_frontbuffer:
	bcall(_Update)
	ld a,(battlePoison)
	or a
	call nz,_Battle_Display_poison
	ld a,(battleStunCounter)
	or a
	jr z,_Battle_Redraw_frontbuffer_no_stun
		ld hl,frontBuffer1 + (35*12) + 8
		ld de,12-3
		ld b,16
		@:
			ld a,(hl)
			or $10
			ld (hl),a
			inc hl
			inc hl
			inc hl
			ld a,(hl)
			or $80
			ld (hl),a
			add hl,de
			djnz {-1@}
		jr _Battle_Redraw_frontbuffer_done_reuben
	_Battle_Redraw_frontbuffer_no_stun:
	ld a,(battleReubenState)
	or a
	jr nz,_Battle_Redraw_frontbuffer_skip_reuben_progress
		call _Battle_Draw_Progressbar_frame
		call _Battle_Progressbar_prepwork
		jr z,{+2@}
		inc b ; we want to run once more often to be able to draw that last pixel correctly
		@:
			push de
			push bc
				ld b,d
				ld c,e
				ld e,1
				ld ix,frontBuffer1
				bcall(_drawPxlOR)
			pop bc
			pop de
			inc d
			djnz {-1@}
		@:
		call _Battle_Player_Disp_HP
		jr z,_Battle_Redraw_frontbuffer_done_reuben
		@:
			push bc
				inc d
				push de
					push de
					pop bc
					ld e,1
					ld ix,frontBuffer1
					bcall(_drawPxlOr)
				pop de
			pop bc
			djnz {-1@}
		jr _Battle_Redraw_frontbuffer_done_reuben
	_Battle_Redraw_frontbuffer_skip_reuben_progress:
	dec a
	jr nz,_Battle_Redraw_frontbuffer_skip_reuben_normalmenu
		call PutBigSpriteXOR_frontbuffer
		.dw getCoordinates(55,20)
		.db bigsprite_normal_attack_menu
		call _Battle_Player_Disp_HP
_Battle_Redraw_frontbuffer_skip_reuben_normalmenu:
	dec a
	jr nz,_Battle_Redraw_frontbuffer_skip_reuben_magicmenu
		call PutBigSpriteXOR_frontbuffer
		.dw getCoordinates(55,20)
		.db bigsprite_magic_attack_menu
		call _Battle_Player_Disp_HP_mp
_Battle_Redraw_frontbuffer_skip_reuben_magicmenu:
_Battle_Redraw_frontbuffer_done_reuben:
	ld a,(battleEnemyStun)
	or a
	ret z ; no stun!
	
	ld ix,frontBuffer1 + 17*12
	ld iy,frontBuffer2 + 17*12
	ld de,12
	ld b,63-17
	-:
		ld c,$80
		ld a,(ix)
		or c
		ld (ix),a
		ld a,(iy)
		or c
		ld (iy),a
		ld c,%00000100
		ld a,(ix+6)
		or c
		ld (ix+6),a
		ld a,(iy+6)
		or c
		ld (iy+6),a
		add ix,de
		add iy,de
		djnz {-}
	
	ld hl,frontBuffer1 + 16*12
	ld de,frontBuffer2 + 16*12
	call _Battle_Redraw_frontbuffer_enemy_stun_1
	
	ld hl,frontBuffer1 + 63*12
	ld de,frontBuffer2 + 63*12
	jp _Battle_Redraw_frontbuffer_enemy_stun_1
_Battle_Redraw_frontbuffer_enemy_stun_1:
	ld a,$ff
	ld b,12
	-:
		ld (hl),a
		inc hl
		ex de,hl
		djnz {-}
	ld a,$fc
	ld (hl),a
	inc hl
	ex de,hl
	ld (hl),a
	ret
_Battle_Player_Disp_HP:
	call BigTextCont
	.dw getCoordinates(55,54)
	.dw string_HPColon
	.db $fe
	.dw reuben_hp
	.db $ff
	ret
_Battle_Player_Disp_HP_mp:
	call BigTextCont
	.dw getCoordinates(55,54)
	.dw string_MPColon
	.db $fe
	.dw reuben_mp
	.db $fd
	.db $ff
	ret


_Battle_Fire_Animation: ; b is x offset
	ld c,b
	ld b,5
	@:
		push bc
			ld b,c
			ld c,22
			ld a,bigsprite_battle_fire
			call PutBigSpriteXOR_frontbuffer_dyn
			bcall(_Sleep_short)
			bcall(_Update)
			bcall(_Sleep_short)
			
			
		pop bc
		djnz {-1@}
	ret
_Battle_Bolt_Animation: ; b is x offset
	ld c,b
	ld b,5
	@:
		push bc
			ld a,5
			sub b
			ld b,c
			add a,a
			add a,a
			add a,a
			ld c,a
			ld a,bigsprite_battle_bolt
			call PutBigSpriteXOR_frontbuffer_dyn
			
			call XORScreen
			bcall(_Sleep_short)
			call XORScreen
			bcall(_Sleep_short)
		pop bc
		djnz {-1@}
	ld b,10
	@:
		push bc
			call XORScreen
			bcall(_Sleep_short)
		pop bc
		djnz {-1@}
	ret
_Battle_Enemy_Blink:
	ld b,4
	@:
		push bc
			ld ix,frontBuffer1
			ld iy,frontBuffer2
			call _Battle_Draw_Enemy_no_buffer
			bcall(_Sleep_short)
			bcall(_Update)
			bcall(_Sleep_short)
		pop bc
		djnz {-1@}
	ret
_Battle_Shake_Screen:
	ld b,$77
	@:
		ld c,$7F
		@:
			ld a,c
			out ($10),a
			
			bcall(_Sleep_veryshort)
			
			dec c
			ld a,c
			cp b
			jr nz,{-1@}
		
		inc b
		inc b
		
		ld a,$40
		out ($10),a
		
		bcall(_Sleep_veryshort)
		ld a,b
		cp $7F
		jr nz,{-2@}
	ret



Multiply:
; 16 bit multiply
;INPUT: hl = factor 1
;;b = factor 2
;;Out: HL is the product, B=0, C preserved, DE=factor1, A=factor2.
	ld a,b
HL_times_A:
	ex de,hl
DE_times_A:
	ld b,8
	ld hl,0
	add hl,hl \ rlca \ jr nc,$+3 \ add hl,de \ djnz $-5
	ret



;===============================================================
BC_Div_DE_round:
;===============================================================
;Performs BC/DE, rounded
;Speed:   1226+10a+6b cycles, 1320cc worst case
;Size:    32 bytes
;Inputs:
;     BC is the numerator
;     DE is the denominator
;Outputs:
;     BC is the quotient
;     DE is divided by 2 (truncated)
;     A reflects the low bits of the quotient
;Destroys: HL
;===============================================================
	ld a,b
	ld hl,0
	ld b,16
	
	rl c
	rla
	adc hl,hl
	sbc hl,de
	jr nc,$+3
	add hl,de
	ccf
	djnz $-11
	rl c
	rla
	ld b,a
	srl d
	rr e
	sbc hl,de
	ret c
	inc bc
	ret


Battle_Instructions_load_Mouse:
	ld hl,enemies + (14*enemy_Mouse)
	ld de,enemy
	ld bc,14
	ldir
	call _Battle_Draw
	ret


.define Battle_Player_Emtpy_Bottle() xor a \ rst rBR_CALL \ .dw _Reuben_set_bottle


_Battle_Player_Item_Bottle:
	bcall(_Reuben_get_bottle)
	or a
	jp z,_Battle_loop_reuben_done ; it's empty, you fool!
	push af
		call _Battle_Reuben_Blink
	pop af
	dec a
	jr z,_Battle_Player_Item_Bottle_dirtyWater
	dec a
	jr z,_Battle_Player_Item_Bottle_Water
	dec a
	jr z,_Battle_Player_Item_Bottle_Herb
	dec a
	jr z,_Battle_Player_Item_Bottle_Potion
	dec a
	jr z,_Battle_Player_Item_Bottle_Ginseng
	dec a
	jr z,_Battle_Player_Item_Bottle_Elixir
	jp _Battle_loop_reuben_done
_Battle_Player_Item_Bottle_dirtyWater:
	ld hl,150
	jr {+}
_Battle_Player_Item_Bottle_Water:
	ld hl,300
	jr {+}
_Battle_Player_Item_Bottle_Herb:
	ld hl,600
	jr {+}
_Battle_Player_Item_Bottle_Potion:
	ld hl,999
+:
	call _Battle_Player_Inc_HP
	Battle_Player_Emtpy_Bottle()
	
	jp _Battle_Player_Reset

_Battle_Player_Item_Bottle_Ginseng:
	ld d,50
	call _Battle_Player_Inc_MP
	Battle_Player_Emtpy_Bottle()
	
	jp _Battle_Player_Reset
_Battle_Player_Item_Bottle_Elixir:
	Battle_Player_Emtpy_Bottle()
	ld hl,(reuben_maxhp)
	ld (reuben_hp),hl
	ld a,(reuben_maxmp)
	ld (reuben_maxmp),a
	bcall(_Update)
	call BigTextCont
	.dw getCoordinates(54,20)
	.dw string_healed
	.db $ff
	bcall(_Sleep_long)
	jp _Battle_Player_Reset
