Battle_Backgrounds:
	ld ix,backBuffer1
	ld iy,backBuffer2
	ld a,(TileMapData+1)
	and $1F
	add a,a
	ld e,a
	ld d,0
	ld hl,_Battle_Backgrounds_LUT
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	
	ld de,12
	ld b,16
	-:
		ld a,(hl)
		ld (ix+ 0),a
		ld (ix+ 2),a
		ld (ix+ 4),a
		ld (ix+ 6),a
		ld (ix+ 8),a
		ld (ix+10),a
		inc hl
		
		ld a,(hl)
		ld (iy+ 0),a
		ld (iy+ 2),a
		ld (iy+ 4),a
		ld (iy+ 6),a
		ld (iy+ 8),a
		ld (iy+10),a
		inc hl
		
		ld a,(hl)
		ld (ix+ 1),a
		ld (ix+ 3),a
		ld (ix+ 5),a
		ld (ix+ 7),a
		ld (ix+ 9),a
		ld (ix+11),a
		inc hl
		
		ld a,(hl)
		ld (iy+ 1),a
		ld (iy+ 3),a
		ld (iy+ 5),a
		ld (iy+ 7),a
		ld (iy+ 9),a
		ld (iy+11),a
		inc hl
		
		add ix,de
		add iy,de
		djnz {-}
	ret

_Battle_Backgrounds_LUT:
	.dw _Battle_Background_Forest ; dogglen, has forest background for enemy explaining
	.dw _Battle_Background_Forest
	.dw _Battle_Background_Forest
	.dw _Battle_Background_Mountains
	.dw _Battle_Background_Aerilon_Castle ; aerilon, has background for speed-learning
	.dw _Battle_Background_Ugana_Plain
	.dw _Battle_Background_Aerilon_Castle
	.dw _Battle_Background_Aerilon_Castle
	.dw _Battle_Background_Dungeon_Blocks
	.dw _Battle_Background_Dungeon_Bombs
	.dw _Battle_Background_Dungeon_Swim
	.dw _Battle_Background_Caves
	.dw 0 ; cliff break
	.dw _Battle_Background_Ugana_Plain
	.dw _Battle_Background_Dungeon_Hookshot
	.dw _Battle_Background_Desert
	.dw _Battle_Background_Ugana_Plain
	.dw _Battle_Background_Sandcastle_present
	.dw _Battle_Background_Sandcastle_present
	.dw _Battle_Background_Sandcastle_past

_Battle_Background_Forest:
	.db $ED,$ED,$ED,$ED,$FF,$12,$FF,$12,$7F,$84,$7F,$84,$BF,$4A,$BF,$4A,$FF,$00,$FF,$00,$FF,$00,$FF,$00,$5F,$00,$5F,$00,$BF,$00,$BF,$00,$FF,$11,$FF,$11,$FF,$EF,$FF,$EF,$DF,$EF,$DF,$EF,$DF,$EF,$DF,$EF,$DE,$EE,$DE,$EE,$58,$68,$58,$68,$9C,$E4,$9C,$E4,$78,$78,$78,$78
_Battle_Background_Mountains:
	.db $00,$10,$00,$10,$00,$81,$00,$00,$C0,$C0,$1F,$1F,$FF,$79,$FF,$CF,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$FF,$7E,$FF,$7E,$FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$7E,$7E,$7E,$7E
_Battle_Background_Ugana_Plain:
	.db $00,$00,$00,$00,$00,$00,$02,$00,$00,$00,$04,$00,$00,$00,$0C,$00,$C0,$00,$0D,$00,$80,$00,$0B,$00,$00,$00,$03,$00,$00,$00,$00,$00,$00,$00,$00,$38,$10,$00,$00,$38,$08,$00,$38,$C6,$0C,$00,$38,$C6,$EC,$00,$10,$EE,$74,$00,$10,$38,$30,$00,$10,$10,$00,$00,$18,$18
_Battle_Background_Aerilon_Castle:
	.db $04,$FF,$04,$FF,$FD,$06,$FD,$06,$FD,$06,$FD,$06,$FF,$FF,$FF,$FF,$51,$F7,$10,$7F,$D1,$73,$1F,$30,$D1,$71,$1F,$10,$FF,$FF,$FF,$FF,$11,$F7,$14,$7F,$F1,$13,$1D,$36,$F1,$11,$1D,$16,$FF,$FF,$FF,$FF,$40,$FF,$40,$FF,$DF,$60,$DF,$60,$DF,$60,$DF,$60,$FF,$FF,$FF,$FF
_Battle_Background_Dungeon_Blocks:
	.db $FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$7E,$7E,$7E,$7E,$0F,$0F,$F0,$F0,$0C,$1F,$30,$F1,$0B,$0F,$D0,$F0,$0B,$4E,$D0,$75,$0B,$0E,$D0,$70,$0B,$1F,$D0,$F0,$0C,$8F,$30,$F4,$0F,$0F,$F0,$F1
_Battle_Background_Dungeon_Bombs:
	.db $FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$7E,$7E,$7E,$7E,$01,$00,$C0,$00,$02,$11,$20,$01,$07,$07,$90,$80,$0F,$4F,$C0,$C5,$0F,$0F,$C0,$C0,$0F,$1F,$C0,$C0,$0F,$8F,$C0,$C4,$07,$07,$80,$81
_Battle_Background_Dungeon_Swim:
	.db $FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$7E,$7E,$7E,$7E,$00,$00,$00,$00,$F8,$00,$F8,$00,$BF,$00,$BF,$00,$4F,$00,$4F,$00,$FF,$00,$FF,$00,$F7,$00,$F7,$00,$E9,$00,$E9,$00,$FF,$00,$FF,$00
_Battle_Background_Caves:
	.db $FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$FF,$7E,$FF,$7E,$FF,$F7,$FF,$F7,$FF,$D9,$FF,$D9,$FF,$49,$FF,$49,$FF,$49,$FF,$49,$FF,$4A,$FF,$4A,$FF,$2A,$FF,$2A,$FF,$EB,$FF,$EB,$7E,$7E,$7E,$7E
_Battle_Background_Dungeon_Hookshot:
	.db $04,$FF,$04,$FF,$FD,$06,$FD,$06,$FD,$06,$FD,$06,$FF,$FF,$FF,$FF,$57,$F9,$70,$9F,$D3,$7D,$3F,$D0,$D1,$77,$1F,$70,$FF,$FF,$FF,$FF,$17,$F9,$74,$9F,$F3,$1D,$3D,$D6,$F1,$17,$1D,$76,$FF,$FF,$FF,$FF,$40,$FF,$40,$FF,$DF,$60,$DF,$60,$DF,$60,$DF,$60,$FF,$FF,$FF,$FF
_Battle_Background_Desert:
	.db $00,$00,$00,$1C,$00,$00,$00,$38,$00,$00,$00,$78,$00,$00,$00,$70,$00,$01,$00,$E0,$00,$07,$00,$80,$00,$0E,$00,$00,$00,$1C,$00,$00,$00,$1C,$00,$00,$00,$38,$00,$00,$00,$78,$00,$00,$00,$70,$00,$00,$00,$E0,$00,$01,$00,$80,$00,$07,$00,$00,$00,$0E,$00,$00,$00,$1C
_Battle_Background_Sandcastle_present:
	.db $99,$E7,$99,$E7,$C1,$7C,$C3,$7E,$E6,$BC,$67,$3D,$7E,$DB,$3E,$9B,$4E,$CB,$7E,$DB,$E3,$B1,$C7,$8D,$C1,$7C,$83,$36,$99,$E5,$18,$66,$98,$E6,$99,$E5,$C3,$7E,$C3,$7E,$E6,$BC,$07,$1D,$5E,$DA,$6E,$CB,$3C,$19,$7E,$DB,$67,$3D,$E7,$BD,$C3,$7E,$C2,$7E,$FF,$FF,$FF,$FF
_Battle_Background_Sandcastle_past:
	.db $99,$E7,$99,$E7,$C3,$7E,$C3,$7E,$E7,$BD,$E7,$BD,$7E,$DB,$7E,$DB,$7E,$DB,$7E,$DB,$E7,$BD,$E7,$BD,$C3,$7E,$C3,$7E,$99,$E7,$99,$E7,$99,$E7,$99,$E7,$C3,$7E,$C3,$7E,$E7,$BD,$E7,$BD,$7E,$DB,$7E,$DB,$7E,$DB,$7E,$DB,$E7,$BD,$E7,$BD,$C3,$7E,$C3,$7E,$FF,$FF,$FF,$FF
