ClrAllBuffers:
	ld hl,frontBuffer1
	call ClrBuffer
	ld hl,frontBuffer2
	call ClrBuffer ; we just continue clearing
ClrBackBuffers:
	ld hl,backBuffer1
	call ClrBuffer
	ld hl,backBuffer2
	jp ClrBuffer
ClrFrontBuffers:
	ld hl,frontBuffer1
	call ClrBuffer
	ld hl,frontBuffer2
	jp ClrBuffer
ClrBuffer:
; Clears a screen buffer
;INPUT: hl = buffer
;Destroys: de
	ld d,h
	ld e,l
	inc de
	ld (hl),0
	ld bc,767
	ldir
	ret
;MakeBufferBlack:
;	ld d,h
;	ld e,l
;	inc de
;	ld (hl),$FF
;	ld bc,767
;	ldir
;	ret




DrawTileMap:
	ld hl,TileMapData+tilemaps_header_size+96
	
	ld b,8
	@:
		push bc
			dec b
			ld a,b
			add a,a
			add a,b
			add a,a
			add a,a
			ld c,a
			ld b,12
			@:
				push bc
					dec hl
					push hl
						ld h,0
						ld l,c
						add hl,hl
						add hl,hl
						add hl,hl
						ld d,0
						ld e,b
						dec e
						add hl,de
						ex de,hl
					pop hl
					ld a,(hl)
					push hl
						ld h,0
						ld l,a
						add hl,hl
						add hl,hl
						add hl,hl
						add hl,hl
						push de
							ld de,sprites
							add hl,de
						pop de
						ld ix,backBuffer1
						ld iy,backBuffer2
						call graySpriteOverwritealigned
					pop hl
				pop bc
				djnz {-1@}
		pop bc
		djnz {-2@}
	ret


graySpriteOverwrite_bothBuffers_by_id:
; a - ID
; bc - positions
	push bc
		ld hl,16
		ld b,a
		bcall(_Multiply)
		ld de,sprites
		add hl,de
	pop bc
graySpriteOverwrite_bothBuffers:
; hl - data
; bc - positions
	push hl
	push bc
		ld ix,backBuffer1
		ld iy,backBuffer2
		call graySpriteOverwrite
	pop bc
	pop hl
graySpriteOverwrite_frontBuffer:
	ld ix,frontBuffer1
	ld iy,frontBuffer2
graySpriteOverwrite:
; hl - data
; bc - positions
; ix - buffer1
; iy - buffer2
	push hl
		ld d,0
		ld e,c
		ld h,d
		ld l,e
		add hl,hl
		add hl,de
		add hl,hl
		add hl,hl
		ld e,b
		srl e
		srl e
		srl e
		add hl,de
		ex de,hl
		add ix,de
		add iy,de
	pop hl
	ld a,b
	and 7
	ld b,8
	jr z,__graySpriteOverwriteAligned
	ld c,a
	@:
		push bc
			ld b,c
			
			ld c,(hl)
			inc hl
			
			ld a,(hl)
			inc hl
			
			push hl
				ld h,a
				ld l,$ff
				ld d,$ff
				
				ld e,0
				_graySpriteOverwriteLoop:  ; shifting: e mask, cd sprite data 1, hl sprite data 2
					srl c
					rr d
					
					srl h
					rr l
					
					rr e
					djnz _graySpriteOverwriteLoop
				ld a,(ix+1)
				or e
				and d
				ld (ix+1),a
				
				ld a,(iy+1)
				or e
				and l
				ld (iy+1),a
				
				ld a,(ix)
				and e
				or c
				ld (ix),a
				
				ld a,(iy)
				and e
				or h
				ld (iy),a
				
				ld de,12
				add ix,de
				add iy,de
			pop hl
		pop bc
		djnz {-1@}
	ret
	
; draws a gray sprite to the back buffers, alligned to the 8*8 grid
; hl - sprite
; de - offset
; ix - buffer1
; iy - buffer2
graySpriteOverwriteAligned:
	add ix,de
	add iy,de
	ld b,8
__graySpriteOverwriteAligned:
	ld de,12
	@:
		ld a,(hl)
		ld (ix),a
		inc hl
		
		ld a,(hl)
		ld (iy),a
		inc hl
		
		add ix,de
		add iy,de
		djnz {-1@}
	ret
