drawHLineXOR:
; ix - buffer1 with offset
; iy - buffer2 with offset
; hl - first/last
; b - middle blocks
	ld a,(ix)
	xor h
	ld (ix),a
	ld a,(iy)
	xor h
	ld (iy),a

	inc ix
	inc iy
	@:
		ld a,(ix)
		cpl
		ld (ix),a
		ld a,(iy)
		cpl
		ld (iy),a
		inc ix
		inc iy
		djnz {-1@}
	ld a,(ix)
	xor l
	ld (ix),a
	ld a,(iy)
	xor l
	ld (iy),a
	ret


drawPxlXOR:
; bc - positions (pixel-wise)
; ix - buffer1
; iy - buffer2
; e - ignore buffer 2?
	push de
		push bc
			ld d,0
			ld e,c
			ld h,d
			ld l,e
			add hl,hl
			add hl,de
			add hl,hl
			add hl,hl
			ld e,b
			srl e
			srl e
			srl e
			add hl,de
			ex de,hl
			add ix,de
			add iy,de
		pop bc
		ld a,b
		and 7
		jr z,_drawPxlXOR_aligned
		ld b,a
		ld a,%10000000
		@:
			srl a
			djnz {-1@}
		ld b,a
	_drawPxlXOR_aligned_back:
		ld a,(ix)
		xor b
		ld (ix),a
	pop de
	xor a
	cp e
	ret nz
	ld a,(iy)
	xor b
	ld (iy),a
	ret
_drawPxlXOR_aligned:
	ld b,%10000000
	jr _drawPxlXOR_aligned_back


	
PutBigSpriteXOR_frontbuffer:
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	jr PutBigSpriteXOR_fixedbuffer_entry
PutBigSpriteXOR_backbuffer:
	ld ix,backBuffer1
	ld iy,backBuffer2
PutBigSpriteXOR_fixedbuffer_entry:
; destroys: all
; takes:
; call PutBigSpriteXOR_backbuffer
; .dw getCoordinates(x,y)
; .db bigsrpite_whatever
	pop hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,(hl)
	inc hl
	push hl
	bcall(_PutBigSpriteXOR)
	ret


PutBigSpriteXOR_frontbuffer_dyn:
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	jr {+}
PutBigSpriteXOR_backbuffer_dyn:
	ld ix,backBuffer1
	ld iy,backBuffer2
+:
	bcall(_PutBigSpriteXOR)
	ret

; display text in bulk
; call with:
; call <routine>
; .dw getCoordinates(x,y)
; .dw <pointer> [.db $fe] <-- if we just want to continue with prev. positions
; [.db $fd] <-- number is only one byte
; ...
; .db $ff
; If <pointer> is in RAM it'll display the number, else text
SmallTextCont:
	ld a,1
	jr TextCont
BigTextCont:
	xor a
TextCont:
	pop hl
	ld d,(hl)
	inc hl
	inc d
	jr nz,{+1@}
	push hl ; that's it
	ret
@:
	inc d
	jr z,{+1@}
	dec d
	dec d
	ld c,d
	ld b,(hl)
	inc hl
@:
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	
	push hl
	ex de,hl
	
	bit 7,h ; if we are in ram ($8000+) this is actually a number
	jr z,{+1@}
	
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	pop ix
	ld l,a
	ld a,(ix)
	cp $fd
	
	jr nz,$+6
	inc ix
	ld d,0
	
	ld a,l
	push ix
	ex de,hl
	
	
	push af
	bcall(_NumText)
	pop af
	jr TextCont
@:
	
	push af
	bcall(_Text_entry)
	pop af
	jr TextCont

XORScreen:
	ld bc,767
	ld hl,frontBuffer1
	ld de,frontBuffer2
	@:
		ld a,(hl)
		cpl
		ld (hl),a
		ld a,(de)
		cpl
		ld (de),a
		inc hl
		inc de
		dec bc
		ld a,b
		or c
		or a
		jr nz,{-1@}
	ret
