Raft_screen:
	ld hl,_Intro_Raft_Buffer1
	ld de,backBuffer1
	call apack_decompress
	ld hl,_Intro_Raft_Buffer2
	ld de,backBuffer2
	call apack_decompress
	
	
	
	; reuben is out on the shore, storm and screen rotating and rain and stuff
	; in tmp1 we have the current row, in tmp2 we have if we rotate up or down.
	xor a
	ld (tmp1),a
	ld hl,tmp2
	res 7,(hl)
	
	ld b,66
	ld c,2
	---:
		push bc
			bcall(_Update)
			
			ld c,10
			--:
				ld b,64 - 12
				bcall(_random_call)
				ld h,0
				ld l,a
				ld d,h
				ld e,l
				
				add hl,hl
				add hl,de
				add hl,hl
				add hl,hl
				ld d,0
				ld b,12
				bcall(_random_call)
				ld e,a
				add hl,de
				ex de,hl
				
				ld ix,frontBuffer1
				ld iy,frontBuffer2
				
				add ix,de
				add iy,de
				ld hl,_Intro_Rain
				ld de,12
				ld b,11
				-:
					ld a,(ix)
					and (hl)
					ld (ix),a
					ld a,(iy)
					and (hl)
					ld (iy),a
					inc hl
					add ix,de
					add iy,de
					djnz {-}
				dec c
				jr nz,{--}
			
			ld a,6
			bcall(_Sleep)
		pop bc
		dec c
		jr nz,{+}
			ld ix,tmp2
			ld hl,tmp1
			bit 7,(ix+0)
			jr nz,{++}
				inc (hl)
				inc (hl)
				ld a,(hl)
				cp 8
				jr nz,{+++}
				set 7,(ix+0)
				jr {+++}
			++:
				dec (hl)
				dec (hl)
				jr nz,{+++}
				res 7,(ix+0)
			+++:
			ld a,(hl)
			or $40
			out ($10),a
			ld c,2
		+:
		dec b
		jp nz,{---}
	ld a,$40
	out ($10),a
	
	
	; lightning
	bcall(_ClrFrontBuffers)
	ld b,3
	-:
		push bc
			ld a,2
			bcall(_Sleep)
			bcall(_Update)
			ld a,2
			bcall(_Sleep)
			bcall(_ClrFrontBuffers)
		pop bc
		djnz {-}
	
	jp Screen_Black
Intro:
	call Raft_screen
	; omnimaga presents screen
	ld hl,string_intro_omnimaga_presents
	ld bc,getCoordinates(0,8)
	ld a,2
	bcall(_Text)
	ld bc,getCoordinates(7*6,6*8)
	ld a,2
	bcall(_Text_continue)
	
	call Pause_text_medlong
	
	; fading to start map
	bcall(_fade_to_white)
	ld a,tilemap_37
	ld (TileMapData),a
	ld a,world_overworld
	ld (reuben_world),a
	bcall(_LoadTileMap)
	bcall(_DrawTileMap)
	ld bc,getCoordinates(6*8,5*8)
	ld a,sprite_blank
	bcall(_graySpriteOverwrite_bothBuffers_by_id)
	
	ld bc,getCoordinates(7*8,3*8)
	ld a,sprite_person
	bcall(_graySpriteOverwrite_bothBuffers_by_id)
	
	bcall(_Update)
	
	ld a,3
	ld (moveDirection),a
	
	ld bc,getCoordinates(8*8,3*8)
	bcall(__Move_Draw_Reuben)
	
	bcall(_fade_from_white)
	
	ld hl,string_intro_find_reuben
	bcall(__SpeechMove_entry)
	
	; move the person to its position
	ld bc,getCoordinates(7*8,3*8)
	-:
		push bc
			ld a,sprite_blank
			bcall(_graySpriteOverwrite_bothBuffers_by_id)
		pop bc
		inc c
		push bc
			ld a,sprite_person
			bcall(_graySpriteOverwrite_bothBuffers_by_id)
		pop bc
		ld a,2
		bcall(_Sleep)
		ld a,c
		cp 5*8
		jr nz,{-}
	-:
		push bc
			ld a,sprite_blank
			bcall(_graySpriteOverwrite_bothBuffers_by_id)
		pop bc
		dec b
		push bc
			ld a,sprite_person
			bcall(_graySpriteOverwrite_bothBuffers_by_id)
		pop bc
		ld a,2
		bcall(_Sleep)
		ld a,b
		cp 6*8
		jr nz,{-}
	
	ret

_Intro_Rain:
	.db %11001111
	.db %11001111
	.db %11001111
	.db %11001111
	.db %10011111
	.db %10011111
	.db %10011111
	.db %10011111
	.db %00111111
	.db %00111111
	.db %00111111

_Intro_Raft_Buffer1:
	.incbin raft_buffer1.bin
_Intro_Raft_Buffer2:
	.incbin raft_buffer2.bin

Outro:
	call Screen_Black
	ld hl,string_outro
	ld bc,getCoordinates(0,12)
	ld a,2
	bcall(_Text)
	call Pause_text_medlong
	call Raft_screen
	call Credits
	
	call Screen_Black
	ld hl,string_outro_2
	ld bc,getCoordinates(0,12)
	ld a,2
	bcall(_Text)
	
	ld bc,getCoordinates(7*6,44)
	ld a,2
	bcall(_Text_continue)
	
	call Pause_text_medlong
	
	jp Pause_text_medlong
	
Credits:
	ld a,$40
	out ($10),a
	call Screen_Black
	
	
	ld hl,string_credits
	; programmed by
	ld bc,getCoordinates(9,20)
	ld a,2
	bcall(_Text)
	call Pause_text_medlong
	
	call Screen_Black
	; maps by
	ld bc,getCoordinates(27,16)
	ld a,2
	bcall(_Text_continue)
	ld bc,getCoordinates(27,40)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	
	call Screen_Black
	; graphics by
	ld bc,getCoordinates(15,12)
	ld a,2
	bcall(_Text_continue)
	push hl
		bcall(_RevUpdate)
	pop hl
	ld bc,getCoordinates(15,28)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	push hl
		bcall(_Update)
	pop hl
	ld bc,getCoordinates(9,28)
	ld a,2
	bcall(_Text_continue)
	ld bc,getCoordinates(9,36)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	
	call Screen_Black
	; Special Thanks
	ld bc,getCoordinates(6,12)
	ld a,2
	bcall(_Text_continue)
	push hl
		bcall(_RevUpdate)
	pop hl
	ld bc,getCoordinates(3,28)
	ld a,2
	bcall(_Text_continue)
	ld bc,getCoordinates(3,36)
	ld a,2
	bcall(_Text_continue)
	ld bc,getCoordinates(3,44)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	push hl
		bcall(_Update)
	pop hl
	ld bc,getCoordinates(0,28)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	
	call Screen_Black
	; www.omnimaga.org
	ld bc,getCoordinates(0,28)
	ld a,2
	bcall(_Text_continue)
	call Pause_text_medlong
	; no ret as we just want to call it twice...

Pause_text_medlong:
	ld a,80
	bcall(_Sleep)
	ret

Screen_Black:
	push hl
		ld a,$ff
		ld hl,backBuffer1
		ld de,backBuffer1+1
		ld bc,767
		ld (hl),a
		ldir
		ld hl,backBuffer2
		ld de,backBuffer2+1
		ld bc,767
		ld (hl),a
		ldir
		bcall(_Update)
	pop hl
	ret
