Inventory:
	push bc
		bcall(_fade_to_white)
		bcall(_ClrBackBuffers)
		ld hl,$ffff
		ld ix,backBuffer1
		ld iy,backBuffer2
		ld b,10
		call drawHLineXOR
		
		ld hl,$ffff
		ld ix,backBuffer1 + (55*12)
		ld iy,backBuffer2 + (55*12)
		ld b,10
		call drawHLineXOR
		
		ld hl,$ffff
		ld ix,backBuffer1 + (63*12)
		ld iy,backBuffer2 + (63*12)
		ld b,10
		call drawHLineXOR
		
		ld b,64
		ld hl,backBuffer1
		ld de,backBuffer2
		--:
			ld a,(hl)
			xor $80
			ld (hl),a
			ld (de),a
			ld c,5
			-:
				inc hl
				inc de
				dec c
				jr nz,{-}
			ld a,b
			cp 9
			jr c,{+}
				ld a,(hl)
				xor $01
				ld (hl),a
				ld (de),a
			+:
			ld c,6
			-:
				inc hl
				inc de
				dec c
				jr nz,{-}
			ld a,(hl)
			xor $01
			ld (hl),a
			ld (de),a
			inc hl
			inc de
			djnz {--}
		
		call PutBigSpriteXOR_backbuffer
		.dw getCoordinates((96-16-2),2)
		.db bigsprite_reuben
		
		isEvent_real(event_pickaxe_offset,event_pickaxe_bit)
		jr z,{+}
			call PutBigSpriteXOR_backbuffer
			.dw getCoordinates(50,2)
			.db bigsprite_pickaxe
		+:
		
		isEvent_real(event_can_swim_offset,event_can_swim_bit)
		jr z,{+}
			call PutBigSpriteXOR_backbuffer
			.dw getCoordinates(58,2)
			.db bigsprite_flippers
		+:
		
		isEvent_real(event_push_blocks_offset,event_push_blocks_bit)
		jr z,{+}
			call PutBigSpriteXOR_backbuffer
			.dw getCoordinates(66,2)
			.db bigsprite_pushblock
		+:
		
		ld a,1
		bcall(_Sleep) ; to make sure it has as few flickering as possible
		bcall(_Update)
		
		
		ld b,4
		-:
			push bc
				ld hl,reuben_events-1
				ld d,0
				ld e,b
				add hl,de
				ld a,(hl)
				bit 7,a
				jr z,{+}
					and $0f
					add a,a ; we need to multiply later on by two, might as well do it now
					ld d,0
					ld e,a
					ld hl,_Inventory_bottlestrings
					add hl,de
					ld e,(hl)
					inc hl
					ld d,(hl)
					ex de,hl
					
					ld a,b
					add a,a ; a times 6
					add a,b
					add a,a
					add a,3
					
					ld c,a
					ld b,6
					
					ld a,1
					bcall(_Text_entry)
				+:
			pop bc
			djnz {-}
		
		isEvent_real(event_item_hookshot_offset,event_item_hookshot_bit)
		jr z,{+}
			call SmallTextCont
			.dw getCoordinates(6,33)
			.dw string_item_hookshot
			.db $ff
		+:
		
		isEvent_real(event_item_bomb_offset,event_item_bomb_bit)
		jr z,{+}
			call SmallTextCont
			.dw getCoordinates(6,39)
			.dw string_item_bomb
			.db $fe
			.dw reuben_bombs
			.db $fd
			.db $ff
		+:
		
		isEvent_real(event_item_protect_offset,event_item_protect_bit)
		jr z,{+}
			call SmallTextCont
			.dw getCoordinates(6,45)
			.dw string_item_protect
			.db $ff
		+:
		
		call SmallTextCont
		.dw getCoordinates(10,2)
		.dw string_item_heading
		.db $ff
		call _Inventory_page1
		
		
		call SmallTextCont
		.dw getCoordinates(2,57)
		.dw string_areaColon
		.db $ff
		ld a,(TileMapData+1)
		and $1F
		ld d,0
		add a,a
		ld e,a
		ld hl,_Inventory_areastrings
		add hl,de
		ld e,(hl)
		inc hl
		ld d,(hl)
		ex de,hl
		; we already have bc (positions) from before
		ld a,1
		bcall(_Text_entry)
		
		bcall(_RevUpdate)
		bcall(_fade_from_white)
		
		
		ld a,(reuben_curitem)
		or a
		
		jr nz,$+3 ; if it is zero we actually select the first element
		inc a
		
		ld b,1
		ld c,a
		
		_Inventory_Keyloop:
			push bc
				bcall(_Update)
			pop bc
			push bc
				ld b,38
				ld a,c
				add a,a ; a times 6
				add a,c
				add a,a
				add a,3
				ld c,a
				
				ld a,bigsprite_hand_left
				call PutBigSpriteXOR_frontbuffer_dyn
				
				ld a,(reuben_curitem)
				or a
				jr z,{+}
					ld c,a
					add a,a ; a times 6
					add a,c
					add a,a
					add a,4
					ld c,a
					
					ld b,2
					ld a,1
					ld hl,string_star
					bcall(_Text_entry)
				+:
			pop bc
			bcall(_Wait_Key_Release)
			bcall(_Wait_Key_Input)
			ld d,a
			bit 3,a ; up
			jr nz,{+}
				dec c
				jr nz,{+}
				inc c
			+:
			bit 0,a ; down
			jr nz,{+}
				inc c
				ld a,c
				cp 8
				jr c,{+}
				dec c
			+:
			ld a,d
			bit 5,a ; 2nd
			jr nz,{+}
				push af
					ld hl,reuben_events-1
					ld d,0
					ld e,c
					add hl,de
					ld a,(hl)
					bit 7,a
					
					jr z,$+6
					ld a,c
					ld (reuben_curitem),a
					
				pop af
			+:
			bit 6,a
			jr nz,{+}
				push af
					push bc
						bcall(_Update)
					pop bc
					call _Inventory_pageb
					inc b
					ld a,b
					cp 4
					jr c,{++}
						ld b,1
					++:
					call _Inventory_pageb
					push bc
						bcall(_RevUpdate)
					pop bc
				pop af
			+:
			bit 7,a
			jr nz,_Inventory_Keyloop
		bcall(_Wait_Key_Release)
		bcall(_fade_to_white)
	ld hl,battle_flags
	bit 1,(hl)
	jr nz,{+}
		bcall(_DrawTileMap)
		bcall(_Update)
		pop bc
		bcall(__Move_Draw_Reuben)
		jr {++}
	+:
		call _Battle_Draw
		pop bc
	++:
	bcall(_fade_from_white)
	ret
_Inventory_pageb:
	push bc
		dec b
		jr nz,{+}
			call _Inventory_page1
			jr {++}
		+:
		dec b
		jr nz,{+}
			call _Inventory_page2
			jr {++}
		+:
		call _Inventory_page3
		++:
	pop bc
	ret
_Inventory_page1:
	call SmallTextCont
	.dw getCoordinates(50,19)
	.dw string_HPColon
	.db $fe
	.dw reuben_hp
	.dw getCoordinates(54,25)
	.dw string_maxColon
	.db $fe
	.dw reuben_maxhp

	.dw getCoordinates(50,31)
	.dw string_MPColon
	.db $fe
	.dw reuben_mp
	.db $fd
	.dw getCoordinates(54,37)
	.dw string_maxColon
	.db $fe
	.dw reuben_maxmp
	.db $fd

	.dw getCoordinates(50,43)
	.dw string_goldColon
	.db $fe
	.dw reuben_gold
	.db $ff
	isEvent_real(event_search_quest_offset,event_search_quest_bit)
	ret z
	call SmallTextCont
	.dw getCoordinates(50,49)
	.dw string_scareColon
	.db $fe
	.dw reuben_fright
	.db $fd
	.db $ff
	ret
_Inventory_page2:
	call SmallTextCont
	.dw getCoordinates(50,19)
	.dw string_levelColon
	.db $fe
	.dw reuben_lvl
	.db $fd

	.dw getCoordinates(50,25)
	.dw string_expColon
	.db $fe
	.dw reuben_exp
	
	.dw getCoordinates(50,31)
	.dw string_weaponColon
	
	.dw getCoordinates(50,43)
	.dw string_armorColon
	.db $ff
	
	ld hl,(reuben_sword)
	ld h,0
	add hl,hl
	ld de,_Inventory_weapon_lut
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	
	ex de,hl
	ld bc,getCoordinates(54,37)
	ld a,1
	bcall(_Text_entry)
	
	ld hl,(reuben_armor)
	ld h,0
	add hl,hl
	ld de,_Inventory_armor_lut - 2 ; armor starts at 1
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	
	ex de,hl
	ld bc,getCoordinates(54,49)
	ld a,1
	bcall(_Text_entry)
	ret
_Inventory_page3:
	call SmallTextCont
	.dw getCoordinates(50,19)
	.dw string_speedColon
	.db $fe
	.dw reuben_wait
	.db $fd

	.dw getCoordinates(50,25)
	.dw string_expNextColon
	.dw getCoordinates(54,31)
	.dw reuben_nextexp
	.db $ff
	ld a,(reuben_tradequest)
	or a
	ret z
	cp 10
	ret z
	push af ; save a byte to push/pop
		call SmallTextCont
		.dw getCoordinates(50,37)
		.dw string_tradeItemColon
		.db $ff
	pop af
	add a,a
	ld h,0
	ld l,a
	ld de,_Inventory_tradequest_lut - 2
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	
	ld bc,getCoordinates(54,43)
	ld a,1
	bcall(_Text_entry)
	ret

_Inventory_tradequest_lut:
	.dw string_tradequest_letter1
	.dw string_tradequest_letter2
	.dw string_tradequest_food
	.dw string_tradequest_fishing_rod
	.dw string_tradequest_fish
	.dw string_tradequest_necklace
	.dw string_tradequest_shell
	.dw string_tradequest_rug
	.dw string_tradequest_fox

_Inventory_weapon_lut:
	.dw string_none
	.dw 0
	.dw string_weapon_stick
	.dw 0
	.dw string_weapon_axe
	.dw string_weapon_sword
	.dw string_weapon_breadsword
	.dw string_weapon_toxicsword

_Inventory_armor_lut:
	.dw string_armor_wounds
	.dw string_none
	.dw 0
	.dw string_armor_shield

_Inventory_bottlestrings:
	.dw string_bottle_empty
	.dw string_bottle_dirty_water
	.dw string_bottle_water
	.dw string_bottle_herb
	.dw string_bottle_potion
	.dw string_bottle_ginseng
	.dw string_bottle_elixir
_Inventory_areastrings:
	.dw string_area_dogglen
	.dw string_area_forest
	.dw string_area_forest
	.dw string_area_mountains
	.dw string_area_aerilon
	.dw string_area_ugana_plain
	.dw string_area_aerilon_castle
	.dw string_area_aerilon_castle
	.dw string_area_eastern_peaks
	.dw string_area_fragile_caves
	.dw string_area_gnah_lake
	.dw string_area_caves
	.dw string_area_cliff_break
	.dw string_area_ugana_plain
	.dw string_area_past_castle
	.dw string_area_desert
	.dw string_area_ugana_plain
	.dw string_area_sandcastle_present
	.dw string_area_sandcastle_present
	.dw string_area_sandcastle_past
