PutBigSpriteXOR:
; sprite XOR
; a - sprite number
; bc - positions
; ix - buffer1
; iy - buffer2
	push bc
		push af ; calculate offset into hl based on positions
		push de
			xor a
			bit 7,c
			jr z,{+}
				dec a
			+:
			ld h,a      ; load ypos into hl and multiply by 12
			ld l,c
			ld d,a
			ld e,l
			add hl,hl
			add hl,de
			add hl,hl
			add hl,hl
			
			ld a,b    ; load xpos into de and devide by 8
			srl b
			srl b
			srl b
			bit 4,b
			jr z,{+}
				ld a,%11100000
				or b
				ld d,$FF
				ld e,a
				jr {++}
			+:
				ld d,0
				ld e,b
			++:
			add hl,de
			
			ex de,hl
			add ix,de
			add iy,de
			
			
			; here it is safe to just destroy hl, de, bc
			ld hl,decompressBackup
			ld de,decompressBackupArea
			ld bc,33
			ldir
			
		pop de
		pop af
		; ix and iy are now offsetted correctly
		
		
		 ; load data offset stuff into de
		    ; and character width into b
		    ; and character height into c
		ld de,EnemySprites
		ld h,0
		ld l,a
		add hl,hl ; a sprite is 2 bytes large in the header
		add hl,de ; we have our full offset now
		
		ld e,(hl) ; ld de,(hl)
		inc hl
		ld d,(hl)
		
		; a is still the number so we can just check if we need to fetch the data from offpage
		cp bigsprites_pageswitch
		jr c,{+}
			; we need to fetch the data off-page!
			bcall(_PutBigSpriteXOR2)
			ld a,(decompressBackupByte)
			ld ($83EB),a
			ld hl,decompressBackupArea+33
			ld de,decompressBackup
			ld bc,33
			ldir
			ld de,decompressArea ; we already know where it is!
		+:
		
		ld a,(de) ; width, deviding by 8 ceiling the number
		srl a
		jr nc,{+}
		inc a
	+:
		srl a
		jr nc,{+}
		inc a
	+:
		srl a
		jr nc,{+}
		inc a
	+:
		ld b,a    ; load it into the var
		inc de
		ld a,(de) ; load height
		ld c,a
		inc de    ; ok the sprites starts here
		
		
		ex de,hl
		; hl - data offset
	pop de
	
	
	
	ld a,d          ; make sure the sprite shifting is only between 0 and 8
	and %00000111
	ld d,a
	
_PutBigSpriteXOR_Drawing:
	ld a,12   ; byte offset into e
	sub b
	ld e,a
	
	ld a,d
	and 7 ; is the sprite alligned to the 8*8 grid?
	jr nz,_PutBigSpriteXOR_not_aligned
	ld d,0
_PutBigSpriteXOR_aligned:
	push bc ; do a row
	@:
		ld a,(ix) ; fetch byte
		xor (hl)
		ld (ix),a
		inc hl
		ld a,(iy)
		xor (hl)
		ld (iy),a
		inc hl
		inc ix
		inc iy
		djnz {-1@}
	pop bc
	add ix,de ; next row!
	add iy,de
	dec c
	jr nz,_PutBigSpriteXOR_aligned
	
	jr _PutBigSpriteXOR_fix_offpage
_PutBigSpriteXOR_not_aligned:
	push bc ; do a row
	@:
		push bc
			ld a,(hl) ; fetch byte
			ld b,d ; left half
			call _PutBigSpriteXOR_ShiftR
			xor (ix)
			ld (ix),a
			
			inc ix
			
			ld a,8 ; right half
			sub d
			ld b,a
			ld a,(hl)
			call _PutBigSpriteXOR_ShiftL
			xor (ix)
			ld (ix),a
			
			inc hl
			
			ld a,(hl) ; fetch byte
			ld b,d ; left half
			call _PutBigSpriteXOR_ShiftR
			xor (iy)
			ld (iy),a
			
			inc iy
			
			ld a,8 ; right half
			sub d
			ld b,a
			ld a,(hl)
			call _PutBigSpriteXOR_ShiftL
			xor (iy)
			ld (iy),a
			
			inc hl ; we don't inc ix/iy as the next byte comes from the other side
		pop bc
		djnz {-1@}
		
		ld b,d
		ld d,0
		add ix,de ; next row!
		add iy,de
		ld d,b
	pop bc
	
	dec c
	jr nz,_PutBigSpriteXOR_not_aligned
	
;	jp _PutBigSpriteXOR_fix_offpage
_PutBigSpriteXOR_fix_offpage:
	ld hl,decompressBackupArea
	ld de,decompressBackup
	ld bc,33
	ldir
	ret
	
_PutBigSpriteXOR_ShiftR:
	srl a
	djnz _PutBigSpriteXOR_ShiftR
	ret
_PutBigSpriteXOR_ShiftL:
	sla a
	djnz _PutBigSpriteXOR_ShiftL
	ret
