LoadTileMap:
	ld a,(reuben_world)
	ld b,a
	ld hl,6
	bcall(_Multiply)
	ld de,worlds
	add hl,de
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	
	push hl
	
	ex de,hl
	
	
	ld a,(TileMapData) ; save map number
_LoadTileMapLoop:
	inc hl ; add five (id, header, offset, pointer)
	inc hl
	inc hl
	inc hl
	inc hl
	
	cp (hl)
	jr nz,_LoadTileMapLoop
	
_LoadTileMapToRam:
	
	
	inc hl
	ld c,(hl) ; header byte
	inc hl
	ld b,(hl) ; offset in decompressed
	inc hl
	
	push bc
		ld e,(hl)
		inc hl
		ld d,(hl)
		ex de,hl
		ld de,backBuffer1
		bit 6,c
		jr z,{+}
			bcall(_LoadTileMap_page1)
			jr {++}
		+:
			call apack_decompress
		++:
	pop bc
	ld hl,TileMapData+1
	ld (hl),c
	
	; we already have offset in b
	ld hl,12*8
	bcall(_Multiply)
	ld de,backBuffer1
	add hl,de
	ld bc,12*8
	ld de,TileMapData+2
	ldir
	
	pop hl
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	
	push hl
	
	;ld a,(TileMapData+1)
	;bit 7,a
	;jr z,_LoadTileMapSkipDynTiles
	
	ex de,hl
	
	_Dyn_Tiles_Loop:
	
		inc hl
		inc hl
		inc hl
		inc hl
		inc hl
		
		ld a,(hl)
		cp $ff
		jr z,_LoadTileMapSkipDynTiles
		ld b,a
		ld a,(TileMapData)
		cp b
		jr nz,_Dyn_Tiles_Loop ; not our map, skip
		push hl
			inc hl
			push hl
				ld a,(hl)
				ld d,0
				ld e,a
				ld hl,reuben_events ; first slot
				add hl,de
				ld a,(hl)
				ld b,a
			pop hl
			inc hl
			ld a,(hl)
			ld c,a
			ld a,b
			and c
			cp c
			jr nz,{+1@} ; no time to parse this yet
			inc hl
			ld a,(hl)
			ld d,0
			ld e,a
			inc hl
			ld a,(hl)
			
			ld hl,TileMapData+2
			add hl,de
			ld (hl),a
		@:
		pop hl
		
		jr _Dyn_Tiles_Loop
	
_LoadTileMapSkipDynTiles:
	
	pop hl
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	
	ld a,$ff ; make sure we clear the previous event tiles
	ld (eventTiles),a
	
	;ld a,(TileMapData+1)
	;bit 6,a
	;jr z,_LoadTileMapSkipActionTiles
	
	ex de,hl
	
	_Action_Tiles_Loop:
		
		inc hl
		inc hl
		inc hl
		
		
		ld a,(hl)
		cp $ff
		ret z
		ld b,a
		ld a,(TileMapData)
		cp b
		jr nz,_Action_Tiles_Loop ; not our map, skip
			inc hl
			ld e,(hl)
			inc hl
			ld d,(hl)
			ex de,hl
			ld de,eventTiles
			@:
				ld bc,3
				ldir
				ld a,(hl)
				cp $FF
				jr nz,{-1@}
			ex de,hl
			ld (hl),$FF
	
_LoadTileMapSkipActionTiles:
	ret
