.export
.binarymode intel

.inclabels "ti8x.lbl"			; Label file containing equates
.include "defines.asm"


_JForceCmd		.equ 402Ah
_homeup			.equ 4558h
_grReset		.equ 4831h

.deflong bjump(label)			; Jump macro
	call BRT_JUMP0
	.dw label
.enddeflong

.deflong bcall(label)			; Call macro
	rst rBR_CALL
	.dw label
.enddeflong

.defpage 0, 16*1024, $4000		; Page 0 definition
.defpage 1, 16*1024, $4000		; Page 1 definition
.defpage 2, 16*1024, $4000		; Page 2 definition
.defpage 3, 16*1024, $4000		; Page 3 definition
.defpage 4, 16*1024, $4000		; Page 4 definition
.defpage 5, 16*1024, $4000		; Page 5 definition

.define _fillBasePageTable $5011

.define frontBuffer1 PlotSScreen
.define frontBuffer2 AppBackUpScreen
.define backBuffer1 SaveSScreen
.define backBuffer2 StatVars
.define getCoordinates(x,y) ((x)*256 + (y)) + 0
.define getCoordinates_portal(x,y) getCoordinates(24 - (x*2 - 1),64 - (y*8 - 1))

; sets an event to 1
.deflong setEvent_real(num,bitnum)
	ld a,(reuben_events + num)
	set bitnum,a
	ld (reuben_events + num),a
.enddeflong

; gets an event, if it is then it returns nz
.deflong isEvent_real(num,bitnum)
	ld a,(reuben_events + num)
	bit bitnum,a
.enddeflong

.deflong clearEvent_real(num,bitnum)
	ld a,(reuben_events + num)
	res bitnum,a
	ld (reuben_events + num),a
.enddeflong

.deflong toggleEvent_real(num,bitnum)
	ld a,(reuben_events + num)
	xor 1<<bitnum
	ld (reuben_events + num),a
.enddeflong

; does a speech thingy
.deflong doSpeech_real(ptr)
	call SpeechMove
	.dw ptr
.enddeflong

; does a battle
.deflong doBattle_real(num)
	ld a,num
	call _Move_Battle_Enemy
.enddeflong

; overwrites with an empty chest
.deflong emptyChest(x,y)
	push bc
		ld bc,getCoordinates(x*8,y*8)
		ld a,sprite_chest_open
		rst rBR_CALL ; bcall macro is added twice --> brass bug?
		.dw _graySpriteOverwrite_bothBuffers_by_id
		;bcall(_graySpriteOverwrite_bothBuffers_by_id)
	pop bc
.enddeflong

.define smallEditCol $8177
;;;; in total 553 bytes
.define TileMapData $8E2C                      ; 98 bytes large
.define LFSRSeed TileMapData+98                ; 8 bytes large
.define enemy LFSRSeed+8                       ; 14 bytes large
.define reuben enemy+14                        ; 46+3 bytes large
.define textBuffer reuben+46+3                   ; 6 bytes large
.define moveDirection textBuffer+6             ; 1 byte large
.define moveCounter moveDirection+1            ; 1 byte large
.define keyPress moveCounter+1                 ; 1 byte large
.define nextEnemyCounter keyPress+1            ; 1 byte large
.define battlePoison nextEnemyCounter+1        ; 1 byte large
.define tmpTile battlePoison+1                 ; 16 bytes large
.define tmpTilePos tmpTile+16                  ; 2 bytes large
.define battleStun tmpTilePos+2                ; 1 byte large
.define battleReubCurWait battleStun+1         ; 1 byte large
.define battleReubenState battleReubCurWait+1  ; 1 byte large
.define tmp1 battleReubenState+1               ; 1 byte large
.define tmp2 tmp1+1                            ; 1 byte large
.define tmp3 tmp2+1                            ; 1 byte large
.define tmp4 tmp3+1                            ; 2 bytes large
.define tmp5 tmp4+2                            ; 1 byte large
.define tmp6 tmp5+1                            ; 2 byte large
.define tmpMap tmp6+2                          ; 1 byte large
.define battleEnemyCurWait tmpMap+1              ; 1 byte large
.define battleStunCounter battleEnemyCurWait+1 ; 1 byte large
.define battleEnemyStun battleStunCounter+1    ; 1 byte
.define interruptMask battleEnemyStun+1        ; 1 byte large
.define interruptCounter interruptMask+1       ; 1 byte large
.define GSCounter interruptCounter+1           ; 1 byte large
.define GSContrast GSCounter+1                 ; 1 byte large
.define walkableTiles GSContrast+1             ; 1 byte large
.define moveStackPointer walkableTiles+1       ; 2 bytes large
.define battle_flags moveStackPointer+2        ; 1 byte large
; 213+3 bytes large
.define apack_decompress battle_flags+1        ; ~243 bytes large


; battle flags:
; 0 - set: maru, reset: normal battle
; 1 - set: in battle, reset: not in battle

.define enemy_id enemy
.define enemy_lvl enemy+1
.define enemy_hp enemy+2
.define enemy_exp enemy+4
.define enemy_sl1 enemy+6
.define enemy_sl2 enemy+7
.define enemy_sl3 enemy+8
.define enemy_sl4 enemy+9
.define enemy_sl5 enemy+10
.define enemy_xpos enemy+11
.define enemy_ypos enemy+12
.define enemy_wait enemy+13

.define reuben_lvl reuben                 ; 1 byte
.define reuben_hp reuben_lvl+1            ; 2 bytes
.define reuben_exp reuben_hp+2            ; 2 bytes
.define reuben_mp reuben_exp+2            ; 1 byte
.define reuben_maxhp reuben_mp+1          ; 2 bytes
.define reuben_nextexp reuben_maxhp+2     ; 2 bytes
.define reuben_maxmp reuben_nextexp+2     ; 1 byte
.define reuben_gold reuben_maxmp+1        ; 2 bytes
.define reuben_events reuben_gold+2       ; 18+3 byte
.define reuben_map reuben_events+18+3       ; 1 byte
.define reuben_x reuben_map+1             ; 1 byte
.define reuben_y reuben_x+1               ; 1 byte
.define reuben_maxgold reuben_y+1         ; 2 bytes
.define reuben_armor reuben_maxgold+2     ; 1 byte
.define reuben_wait reuben_armor+1        ; 1 byte
.define reuben_sword reuben_wait+1        ; 1 byte
.define reuben_curitem reuben_sword+1     ; 1 byte
.define reuben_world reuben_curitem+1     ; 1 byte
.define reuben_tradequest reuben_world+1  ; 1 byte
.define reuben_fright reuben_tradequest+1 ; 1 byte
.define reuben_bombs reuben_fright+1      ; 1 byte
.define reuben_maxbombs reuben_bombs+1    ; 1 byte
.define tilemap_pos_id reuben_maxbombs+1  ; 1 byte

.define item_none 0
.define item_bottle1 1
.define item_bottle2 2
.define item_bottle3 3
.define item_bottle4 4
.define item_hookshot 5
.define item_bomb 6
.define item_protect 7

.define item_pushblock 8

.define bottle_emtpy 0
.define bottle_dirty_water 1
.define bottle_water 2
.define bottle_herb 3
.define bottle_potion 4
.define bottle_ginseng 5
.define bottle_elixir 6

; smallEditRam is 108 bytes in total, preserve all for the event tiles
.define eventTiles smallEditRam

.define textShadPtrs $8588
.define keyToStr $9D76
.define basepage $8584

.define decompressArea $8101 ; all until $843e
.define decompressBackup $8230 ; we need to backup these 33 bytes
.define decompressBackupArea $846E ; 66 bytes
.define decompressBackupByte decompressBackupArea+66 ; 1 byte

.define listEditPtrs $96FC
.define animTilesBuffer cmdShadow  ; size: 128 + 6 + 8 + 121 + 48 = 311
.define animTilesBufferFrame1 animTilesBuffer
.define animTilesBufferFrame2 animTilesBufferFrame1 + 155
; DON'T USE
; appData
; ramCode
; smallEditCol
; textShadow
; textShadPtrs
; progCurrent
; keyToStr
; cmdShadow
; editPtrs
; listEditPtrs
; graphTypes
; graphVariables
.page 0
.define APPNAME "Reuben 3"
.define APPPAGES 6
.include header.asm
	jp Run
	.branch Start
	.branch Stop
	.branch Load
	.branch Save
	.branch Intro
	.branch Outro
	.branch Credits
	.branch Titlescreen
	.branch random_call
	.branch ResetGameData
	.branch BattleEngine
	
	.branch ClrAllBuffers
	.branch ClrBackBuffers
	.branch ClrFrontBuffers
	.branch Update
	.branch RevUpdate
	.branch PutBigSpriteXOR
	.branch GrayTuner
	.branch DrawTileMap
	.branch graySpriteOverwrite
	.branch graySpriteOverwriteAligned
	.branch graySpriteOverwrite_bothBuffers_by_id
	.branch graySpriteOverwrite_bothBuffers
	.branch graySpriteOverwrite_frontBuffer
	.branch _Move_Draw_Reuben_With_Erase
	.branch _Move_Draw_Reuben
	.branch fade_to_white
	.branch fade_from_white
	.branch Battle_Backgrounds
	.branch drawPxlOR
	
	.branch UpdateWalkableTiles
	.branch SetBattleCounter
	.branch LoadTileMap
	.branch Multiply
	.branch Sleep_veryshort
	.branch Sleep_short
	.branch Sleep_med
	.branch Sleep_medmedlong
	.branch Sleep_medlong
	.branch Sleep_long
	.branch Sleep
	.branch Wait_Key_Input
	.branch Wait_Key_Release
	
	.branch NumText
	.branch _SpeechMove_entry
	.branch Text
	.branch Text_continue
	.branch Text_entry
	.branch Speech_Ask_Textpage
	
	.branch Script
	.branch _Script_nosave
	.branch Map_Menu
	.branch Inventory
	
	.branch LoadTileMap_page1
	.branch Offpage_Text_Decompress
	.branch PutBigSpriteXOR2
	
	.branch Reuben_add_Gold
	.branch Reuben_add_Bombs
	.branch Reuben_add_HP
	
	.branch Battle_Instructions_load_Mouse
	.branch _Battle_Redraw_frontbuffer
	.branch _Battle_Player_Attack_animation
	.branch Reuben_get_bottle
	.branch Reuben_set_bottle
Run:
	in a,(6) ; store basepage
	ld (basepage),a
	
	bcall(_Start)
	
	
	
-:
	bcall(_Load)
	
	bcall(_Titlescreen)
	

	isEvent_real(event_game_started_offset,event_game_started_bit)
	jr nz,{+}
		bcall(_Intro)
		setEvent_real(event_game_started_offset,event_game_started_bit)
		bcall(_UpdateWalkableTiles)
	+:
	;call setRandomSeed ; This is only called like once
	; we inline this function instead now
;------set random seed for LFSR
; destroys: none
setRandomSeed:
_setRandomSeed_actual:
	ld a,r
	ld (LFSRSeed),a
	ld (LFSRSeed+1),a
	ld (LFSRSeed+2),a
	ld (LFSRSeed+3),a
	ld a,r
	ld (LFSRSeed+4),a
	ld (LFSRSeed+5),a
	ld (LFSRSeed+6),a
	ld (LFSRSeed+7),a
	
	
	ld hl,LFSRSeed
	ld b,8
	xor a
	or (hl)
	inc hl
	djnz $-2
	or a
	jr z,_setRandomSeed_actual
	
; ret
	; set random seed done
	
	
	bcall(_LoadTileMap)
	bcall(_DrawTileMap)
	call Update
	
	
	ld hl,reuben_x
	ld b,(hl)
	inc hl
	ld c,(hl)
	GameLoop:
		call Move
		or a
		jr z,GameLoop
	jr {-}




SetBattleCounter:
	ld b,180
	bcall(_random_call)
	add a,80-4 ; bitrange!
	ld (nextEnemyCounter),a
	ret


Wait_Key_Input:
	in a,(1) ; get keypress
	cp $FF
	jr nc,Wait_Key_Input
	ret
Wait_Key_Release:
	push af
	@:
		in a,(1) ; get keypress
		cp $FF
		jr c,{-1@}
	pop af
	ret
Sleep_short:
	ld a,2
	jr Sleep
Sleep_med:
	ld a,5
	jr Sleep
Sleep_medmedlong:
	ld a,10
	jr Sleep
Sleep_medlong:
	ld a,15
	jr Sleep
Sleep_long:
	ld a,30
Sleep:
; a - number
; preserves all
	push bc
		ld b,a
		_Sleep_loop:
			call Halt
		djnz _Sleep_loop
	pop bc
	ret

Sleep_veryshort:
Halt:
	push hl
		ld hl,interruptMask
		res 7,(hl)
		-:
			bit 7,(hl)
			jr z,{-}
		res 7,(hl)
	pop hl
	ret




.include "move.asm"
.include "bottle.asm"
.include "hookshot.asm"
.include "bomb.asm"

.include "graphics_firstpage.asm"

.include "speech.asm"
.include "areas.asm"
.include "reuben_routines.asm"
.include "eventtiles.asm"


.include "startstop.asm"
.include "gray.asm"
.include "apack.asm"

.echoln "bytes in use on page ",#,": ",$-$4000
.page 1
	.include "loadMaps.asm"
	.include "maps.asm"
	
.echoln "bytes in use on page ",#,": ",$-$4000
.page 2
	.include "text.asm"
	.include "strings.asm"
	.include "font.asm"
.echoln "bytes in use on page ",#,": ",$-$4000
.page 3
	.include "loadEnemysprites.asm"
	.include "largeSprites.asm"
	
.echoln "bytes in use on page ",#,": ",$-$4000
.page 4
	.include "loadMaps1.asm"
	.include "maps1.asm"
	
	
	.include "inventory.asm"
	.include "battle.asm"
	.include "graphics_battlepage.asm"
	.include "enemies.asm"
	
	
	.include "random.asm"
	
	.include "battle_backgrounds.asm"
.echoln "bytes in use on page ",#,": ",$-$4000
.page 5
	.include "text2.asm"
	.include "strings2.asm"
	
	
	.include "map_menu.asm"
	
	.include "sprites.asm"
	.include "graphics.asm"
	
	.include "introoutro.asm"
	
	.include "titlescreen.asm"
	
	.include "loadEnemysprites2.asm"
	.include "largeSprites2.asm"
	
	
	.include "script.asm"
.echoln "bytes in use on page ",#,": ",$-$4000


.echoln "reuben data length    : ",ReubenDefaultDataLen
.echoln "Apack size            : ",apack_end-apack_decompress_real

.end
