Move:
	ld (moveStackPointer),sp
	call _Move_Draw_Reuben
	
	ld a,(reuben_world)
	cp world_overworld
	jr nz,{+}
	
	ld a,(TileMapData)
	jr {++}
+:
	cp world_past
	jr nz,_Move_Loop_fixstack

	ld a,(TileMapData)
	add a,tilemaps_width*4 + 0
++:
	ld (tilemap_pos_id),a
_Move_Loop_fixstack:
	ld sp,(moveStackPointer)
_Move_Loop:
	ld a,$ff
	out (1),a
	ld a,%10111110
	out (1),a
	ex (sp),hl
	ex (sp),hl
	in a,(1)
	ld (keyPress),a
	bit 7,a ; del key
	jp z,_Move_Exit_Dialog
	bit 6,a ; MODE key
	jr nz,{+}
		ld d,0
		-:
			in a,(1)
			bit 5,a ; 2nd
			jr nz,{++}
				ld d,1
			++:
			cp $ff
			jr c,{-}
		xor a
		cp d
		jr nz,{++}
			bcall(_Inventory)
			jr {+++}
		++:
			bcall(_Map_Menu)
		+++:
		ld a,$ff
	+:
	cpl
	and $0F
	jr nz,_Move_Arrowpress
_Move_After_Arrowpresses:
	ld a,(keyPress)
	bit 5,a ; 2ND key
	jp z,_MoveAction
	
	ld a,$ff
	out (1),a
	ld a,%11011111
	out (1),a
	ex (sp),hl
	ex (sp),hl
	in a,(1)
	bit 7,a ; ALPHA
	jp z,_MoveItem
	
	jr _Move_Loop

_Move_Arrowpress:
	ld a,(keyPress)
	bit 0,a
	jp z,_Move_Down
_Move_After_Down:
	ld a,(keyPress)
	bit 1,a
	jp z,_Move_Left
_Move_After_Left:
	ld a,(keyPress)
	bit 2,a
	jp z,_Move_Right
_Move_After_Right:
	ld a,(keyPress)
	bit 3,a
	jp z,_Move_Up
_Move_After_Up:

	ld de,getCoordinates(3,3) ; we want it to be inside of reuben...heehee *inside*
	call _Move_Grab_Tile
	ld a,$ff
	call _MoveAction_loadScript
	
	
	call Sleep_short
	
	ld hl,moveCounter
	inc (hl)
	call _Move_Draw_Reuben_With_Erase
	
	
	ld a,b
	xor c
	ld hl,reuben_x
	xor (hl)
	ld hl,reuben_y
	xor (hl)
	
	ld a,c
	ld (hl),a ; hl is still reuben_y
	ld a,b
	ld (reuben_x),a
	jp z,_Move_After_Arrowpresses
	
	ld hl,nextEnemyCounter
	dec (hl)
	jp nz,_Move_After_Arrowpresses
	
	push bc
		
		call SetBattleCounter ; we need a new counter either way
		
		; we have an enemy attack
		ld a,(TileMapData+1)
		bit 7,a
		jr nz,{+}
		
		pop bc
		jp _Move_After_Arrowpresses
		
		+:
		and %00011111
		
		ld d,0
		ld e,a  ; a * 10 --> hl
		ld h,d
		ld l,e
		add hl,hl
		add hl,hl
		add hl,de
		add hl,hl
		
		ld de,_Move_Battle_Enemies
		add hl,de
		ld b,10
		bcall(_random_call)
		ld e,a
		ld d,0
		add hl,de
		ld a,(hl)
		cp $FF
	pop bc
	
	jp z,_Move_After_Arrowpresses
	
	push af
		; ok, time to check if we protect ourselves via item
		ld a,(reuben_curitem)
		cp item_protect
		jr nz,{+}
			; let's see if we have 5MP at all
			push bc
				call _Battle_use_mp_5
			pop bc
			jp nc,_Move_Loop_fixstack
		+:
	pop af
	
	ld hl,_Move_Loop ; we "call" _Move_Battle_Enemy
	push hl
	
_Move_Battle_Enemy:
	push bc
		bcall(_BattleEngine)
	pop bc
	or a
	jr nz,{+}; we are dead
	
	push bc
	;	call Wait_Key_Release
		bcall(_ClrBackBuffers)
		bcall(_DrawTileMap)
		call Update
	pop bc
	jp _Move_Draw_Reuben
+:
	ld sp,(moveStackPointer)
	ret

_Move_Down:
	ld a,2
	ld (moveDirection),a
	
	ld a,c
	cp 56 ; at bottom of screen
	jp z,_Move_Exit_Down
	
	; collision check
	ld de,$0008 ; 0,8 ; lower left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Down_Align_Right
	
	ld de,$0708 ; 7,8 lower right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Down_Align_Left
	
	inc c
	jp _Move_After_Down
_Move_Down_Align_Right:
	ld a,(keyPress)
	bit 1,a
	jp z,_Move_After_Down ; we want to move left!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Down ; may not be alligned
	
	ld de,$0800 ; 8,0 ; tile to the right
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	ld de,$0808 ; 8,8 tile to the right down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	inc b
	
	jp _Move_After_Up ; that's it folks!
_Move_Down_Align_Left:
	ld a,(keyPress)
	bit 2,a
	jp z,_Move_After_Down ; we want to move right!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Down ; may not be alligned
	
	ld de,$FF00 ; -1,0 ; tile to the left
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	ld de,$FF08 ; -1,8 tile to the left down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Down
	
	dec b
	
	jp _Move_After_Up ; that's it folks!
_Move_Left:
	ld a,3
	ld (moveDirection),a
	
	ld a,b
	or a
	jr nz,{+}
		ld de,0
		call _Move_Grab_Tile
		cp sprite_blank
		; ok, if we have a door all at the edge that also means that there is a walkable tile below so we align ourselves down
		jp nc,_Move_Exit_Left ; at left
		ld a,(keyPress)
		bit 0,a
		jp z,_Move_After_Left ; already moved down
		bit 3,a
		jp z,_Move_After_Left ; we want to move up!
		bit 5,a
		jp z,_Move_After_Arrowpresses ; we hit 2ND
		inc c
		jp _Move_After_Left
	+:
	; collision check
	ld de,$FF00 ; 0,0 ; upper left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Left_Align_Down
	
	ld de,$FF07 ; lower left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Left_Align_Up
	
	dec b
	jp _Move_After_Left
_Move_Left_Align_Down:
	ld a,(keyPress)
	bit 0,a
	jp z,_Move_After_Left ; already moved down
	bit 3,a
	jp z,_Move_After_Left ; we want to move up!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Left ; may not be alligned
	
	ld de,$0008 ; 0,8 ; tile to the down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	ld de,$FF08 ; -1,8 tile to the left down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	inc c
	
	jp _Move_After_Up ; that's it folks!
_Move_Left_Align_Up:
	ld a,(keyPress)
	bit 0,a
	jp z,_Move_After_Left ; we want to move up!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Left ; may not be alligned
	
	ld de,$0001 ; 0,1 ; tile to the up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	ld de,$FF01 ; -1,1 tile to the left up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Left
	
	dec c
	
	jp _Move_After_Up ; that's it folks!
_Move_Right:
	ld a,1
	ld (moveDirection),a
	
	ld a,b
	cp 88 ; at right of screen
	jr nz,{+}
		ld de,0
		call _Move_Grab_Tile
		cp sprite_blank
		; ok, if we have a door all at the edge that also means that there is a walkable tile below so we align ourselves down
		jp nc,_Move_Exit_Right
		ld a,(keyPress)
		bit 0,a
		jp z,_Move_After_Right ; already moved down
		bit 3,a
		jp z,_Move_After_Right ; wanting to move up!
		bit 5,a
		jp z,_Move_After_Arrowpresses ; we hit 2ND
		inc c
		jp _Move_After_Right
	+:
	
	; collision check
	ld de,$0800 ; 8,0 ; upper right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Right_Align_Down
	
	ld de,$0807 ; lower right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Right_Align_Up
	
	inc b
	jp _Move_After_Right
_Move_Right_Align_Down:
	ld a,(keyPress)
	bit 0,a
	jp z,_Move_After_Right ; already moved down
	bit 3,a
	jp z,_Move_After_Right ; wanting to move up!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Right ; may not be alligned
	
	ld de,$0008 ; 0,8 ; tile to the down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	ld de,$0808 ; -1,8 tile to the right down
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	inc c
	
	jp _Move_After_Up ; that's it folks!
_Move_Right_Align_Up:
	ld a,(keyPress)
	bit 0,a
	jp z,_Move_After_Right ; we want to move down!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,c
	and 7 ; modulus 8
	jp z,_Move_After_Right ; may not be alligned
	
	ld de,$00FF ; 0,-1 ; tile to the up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	ld de,$08FF ; 8,-1 tile to the right up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Right
	
	dec c
	
	jp _Move_After_Up ; that's it folks!
_Move_Up:
	xor a
	ld (moveDirection),a
	
	ld a,c
	cp 0 ; at top
	jp z,_Move_Exit_Up
	
	; collision check
	ld de,$00FF ; 0,-1 ; upper left corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Up_Align_Right
	
	ld de,$07FF ; 7,-1 upper right corner
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jr nc,_Move_Up_Align_Left
	
	dec c
	jp _Move_After_Up
_Move_Up_Align_Right:
	ld a,(keyPress)
	bit 1,a
	jp z,_Move_After_Up ; we want to move left!
	bit 2,a
	jp z,_Move_After_Up ; already moved right
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND
	
	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Up ; may not be alligned
	
	ld de,$0800 ; 8,0 ; tile to the right
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	ld de,$08FF ; 8,-1 tile to the right up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	inc b
	
	jp _Move_After_Up ; that's it folks!
_Move_Up_Align_Left:
	ld a,(keyPress)
	bit 1,a
	jp z,_Move_After_Up ; already moved left
	bit 2,a
	jp z,_Move_After_Up ; we want to move right!
	bit 5,a
	jp z,_Move_After_Arrowpresses ; we hit 2ND

	ld a,b
	and 7 ; modulus 8
	jp z,_Move_After_Up ; may not be alligned
	
	ld de,$FF00 ; -1,0 ; tile to the left
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	ld de,$FFFF ; -1,-1 tile to the left up
	call _Move_Grab_Tile
	call _Move_Is_Tile_Walkable
	jp nc,_Move_After_Up
	
	dec b
	
	jp _Move_After_Up ; that's it folks!

_Move_Erase_Reuben:
	push bc
		ld ix,frontBuffer1
		ld iy,frontBuffer2
		ld hl,tmpTile
		ld bc,(tmpTilePos)
		bcall(_graySpriteOverwrite)
	pop bc
	ret
_Move_Draw_Reuben_With_Erase:
	push bc
		ld ix,frontBuffer1
		ld iy,frontBuffer2
		ld hl,tmpTile
		ld bc,(tmpTilePos)
		bcall(_graySpriteOverwrite)
	pop bc
_Move_Draw_Reuben:
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	ld hl,tmpTile
	push bc
		call GetSprite
	pop bc
	ld (tmpTilePos),bc
	ld ix,frontBuffer1
	ld iy,frontBuffer2
	push bc
		ld a,(moveDirection) ; load direction and multiply with 48
		ld d,a
		add a,a
		add a,d
		add a,a
		add a,a
		add a,a
		add a,a
		ld e,a
		ld d,0
		
		ld hl,moveCounter
		ld a,(hl)
		bit 2,a
		jr z,{+1@}
			ld a,e
			add a,8+8+8
			ld e,a
		@:
		push de
			ld de,$0404
			call _Move_Grab_Tile
			cp sprite_after_walk
			jr c,{+1@}
				ld hl,ReubenSpritesSwim
				call Sleep_veryshort
				jr {+2@}
			@:
				ld hl,ReubenSprites
			@:
		pop de
		add hl,de
		
		call graySpriteMasked
	pop bc
	ret

_Move_Is_Tile_Walkable:
;if carry is set then tile is walkable
;INPUT: a - tile
	ld hl,(walkableTiles)
	cp l
	ret



_MoveAction:
	ld hl,_Move_Loop
	push hl ; we basically call this thing
_MoveAction_entry:
	ld a,(moveDirection)
	
	;grab tiles
	or a
	jr z,_MoveAction_Up
	
	dec a
	jr z,_MoveAction_Right
	
	dec a
	jp z,_MoveAction_Down
	
	jp _MoveAction_Left
	
_MoveAction_AfterGrabTile_prework:
	call _Move_Grab_Tile
	
	cp sprite_shrub ; shrub
	jp z,_Move_Action_Shrub
	
	cp sprite_rock
	jp z,_Move_Action_Rock
	
	cp sprite_aliolla
	jp z,_Move_Action_Aliolla
	
	cp sprite_block
	jp z,_Move_Action_Block
	
	cp sprite_first_water
	jr c,{+}
		cp sprite_after_water
		jp c,_Move_Action_Water
	+:
	
	cp sprite_first_bomb ; bomb events can only be called by bombs
	jr c,{+}
		cp sprite_after_bomb
		ret c
	+:
	
	cp sprite_save
	jp z,_Move_Action_Save

_MoveAction_checkScripts:
	cp sprite_after_swim ; only non-walkable tiles can be interactable with 2nd
	ret c
	
	; ok no fixed tiles like shrubs etc. so we have to check our "dynamic" code
	
	
	xor a ; ld a,item_none
_MoveAction_loadScript:
; takes:
; a - item that triggerd it
; e - offset within map(_Move_Grab_Tile)
; destroys: all
	; we want to change the return address as we do additional checks
	ld hl,_MoveAction_loadScript_exit_success
	
	push af
	push hl
	
	push af
		ld hl,eventTiles
		@:
			ld a,(hl)
			inc hl
			cp e
			jr z,{+1@}
			cp $FF
			jp z,_MoveAction_loadScript_exit ; that's it folks
			inc hl
			inc hl
			jr {-1@}
		@:
		ld e,(hl)
		inc hl
		ld d,(hl)
		ex de,hl
	pop af
	jp (hl)
_MoveAction_loadScript_exit:
	pop af
	pop de
	pop af
	ret
_MoveAction_loadScript_exit_success:
	pop af
	or a
	jp z,_Move_Loop_fixstack
	ret

_MoveAction_Up:
	ld a,c
	cp 7
	ret c ; too far to the top
	and 7 ; modulus 8
	ret nz ; need to be aligned
	
	ld de,$04F8 ; 4,-8
	
	jr _MoveAction_AfterGrabTile_prework
_MoveAction_Right:
	ld a,b
	cp 87
	ret nc ; too far to the right
	and 7 ; modulus 8
	ret nz ; need to be aligned
	
	ld de,$0804 ; 8,4
	
	jr _MoveAction_AfterGrabTile_prework
_MoveAction_Down:
	ld a,c
	cp 55
	ret nc ; too far down
	and 7 ; modulus 8
	ret nz ; need to be aligned
	
	ld de,$0408 ; 4,8
	
	jp _MoveAction_AfterGrabTile_prework
_MoveAction_Left:
	ld a,b
	cp 7
	ret c ; too far left
	and 7 ; modulus 8
	ret nz ; need to be aligned
	
	ld de,$F804 ; -8,4
	
	jp _MoveAction_AfterGrabTile_prework


_Move_Action_Shrub:
	call _Move_Action_Remove_Tile
	jp _Move_Action_Release_2nd
_Move_Action_Remove_Tile:
	push bc ; save positions
	
		ld (hl),sprite_blank ; remove it
		
		call _Move_Grab_Tile_To_Sprite_Positions
		
		ld hl,sprites+(sprite_blank*16)
		
		bcall(_graySpriteOverwrite_bothBuffers)
		
	pop bc
	
	ret

_Move_Action_Release_2nd:
	; we can't use Wait_Key_Release here as we only want to wait for released 2ND
	ld a,$ff
	out (1),a
	ld a,%11011111
	out (1),a
	ex (sp),hl
	ex (sp),hl
	-:
		in a,(1)
		bit 7,a
		jr z,{-}
	ld a,$ff
	out (1),a
	ld a,%10111110
	out (1),a
	ex (sp),hl
	ex (sp),hl
	-:
		in a,(1)
		bit 5,a
		jr z,{-}
	
	jp _Move_Loop_fixstack

_Move_Action_Rock:
	isEvent_real(event_pickaxe_offset,event_pickaxe_bit)
	jp z,_Move_Loop_fixstack
	call _Move_Action_Remove_Tile
	jr _Move_Action_Release_2nd

_Move_Action_Aliolla:
	ld a,(reuben_armor)
	dec a
	jr nz,{+}
		ld a,2
		ld (reuben_armor),a
		doSpeech_real(string_find_aliolla)
		jr {++}
	+:
	doSpeech_real(string_see_aliolla)
	++:
	jp _Move_Loop_fixstack

_Move_Action_Block:
	isEvent_real(event_push_blocks_offset,event_push_blocks_bit)
	jp z,_Move_Loop_fixstack
	push bc
	ld a,(moveDirection)
	or a
	jr z,_Move_Action_Block_Up_Check
	dec a
	jr z,_Move_Action_Block_Right_Check
	dec a
	jr z,_Move_Action_Block_Down_Check
	
	; so left it is
_Move_Action_Block_Left_Check:
	ld a,b
	cp 15
	jp c,_Move_Loop_fixstack ; too far left
	ld de,$F004 ; -16,4

	jr _Move_Action_Block_After_Check
_Move_Action_Block_Up_Check:
	ld a,c
	cp 15
	jp c,_Move_Loop_fixstack ; too far up
	ld de,$04F0 ; 4,-16
	
	jr _Move_Action_Block_After_Check
_Move_Action_Block_Right_Check:
	ld a,b
	cp 79
	jp nc,_Move_Loop_fixstack ; too far right
	ld de,$1004 ; 16,4
	
	jr _Move_Action_Block_After_Check
_Move_Action_Block_Down_Check:
	ld a,c
	cp 47
	jp nc,_Move_Loop_fixstack ; too far down
	ld de,$0410 ; 4,16
	
_Move_Action_Block_After_Check:
	
	call _Move_Grab_Tile
	cp sprite_after_walk
	jp nc,_Move_Loop_fixstack ; we can't move the block here
	
	ld a,(moveDirection)
	
	or a
	jr z,_Move_Action_Block_Up_Move
	dec a
	jp z,_Move_Action_Block_Right_Move
	dec a
	jp z,_Move_Action_Block_Down_Move
	
	; so left it is
_Move_Action_Block_Left_Move:
	ld de,$F804 ; -8,4
	call _Move_Grab_Tile
	push de
	
	push de
		ld (hl),sprite_blank ; remove it
		ld de,-1
		add hl,de
		ld (hl),sprite_block
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	push bc
		ld hl,sprites+(sprite_blank*16)
		ld ix,backBuffer1
		ld iy,backBuffer2
		bcall(_graySpriteOverwrite)
	pop bc
	
	ld d,8
	-:
		push de
			push bc
				ld hl,sprites+(sprite_blank*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			
			dec b ; we move left
			
			push bc
				ld hl,sprites+(sprite_block*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			call Sleep_short
		pop de
		dec d
		jr nz,{-}
	
	jp _Move_Action_Block_Cleanup

_Move_Action_Block_Up_Move:
	ld de,$04F8 ; 4,-8
	call _Move_Grab_Tile
	push de
	
	push de
		ld (hl),sprite_blank ; remove it
		ld de,-12
		add hl,de
		ld (hl),sprite_block
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	push bc
		ld hl,sprites+(sprite_blank*16)
		ld ix,backBuffer1
		ld iy,backBuffer2
		bcall(_graySpriteOverwrite)
	pop bc
	
	ld d,8
	-:
		push de
			push bc
				ld hl,sprites+(sprite_blank*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			
			dec c ; we move up
			
			push bc
				ld hl,sprites+(sprite_block*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			call Sleep_short
		pop de
		dec d
		jr nz,{-}
	
	jp _Move_Action_Block_Cleanup

_Move_Action_Block_Right_Move:
	ld de,$0804 ; 8,4
	call _Move_Grab_Tile
	push de
	
	push de
		ld (hl),sprite_blank ; remove it
		ld de,1
		add hl,de
		ld (hl),sprite_block
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	push bc
		ld hl,sprites+(sprite_blank*16)
		ld ix,backBuffer1
		ld iy,backBuffer2
		bcall(_graySpriteOverwrite)
	pop bc
	
	ld d,8
	-:
		push de
			push bc
				ld hl,sprites+(sprite_blank*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			
			inc b ; we move up
			
			push bc
				ld hl,sprites+(sprite_block*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			call Sleep_short
		pop de
		dec d
		jr nz,{-}
	
	jr _Move_Action_Block_Cleanup

_Move_Action_Block_Down_Move:
	ld de,$0408 ; 4,8
	call _Move_Grab_Tile
	push de
	
	push de
		ld (hl),sprite_blank ; remove it
		ld de,12
		add hl,de
		ld (hl),sprite_block
	pop de
	
	; animation
	
	call _Move_Grab_Tile_To_Sprite_Positions
	push bc
		ld hl,sprites+(sprite_blank*16)
		ld ix,backBuffer1
		ld iy,backBuffer2
		bcall(_graySpriteOverwrite)
	pop bc
	
	ld d,8
	-:
		push de
			push bc
				ld hl,sprites+(sprite_blank*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			
			inc c ; we move up
			
			push bc
				ld hl,sprites+(sprite_block*16)
				bcall(_graySpriteOverwrite_frontBuffer)
			pop bc
			call Sleep_short
		pop de
		dec d
		jr nz,{-}
	

_Move_Action_Block_Cleanup:
	ld hl,sprites+(sprite_block*16)
	ld ix,backBuffer1
	ld iy,backBuffer2
	bcall(_graySpriteOverwrite)
	pop de
	
	pop bc
	
	ld a,item_pushblock
	call _MoveAction_loadScript ; we _need_ to fix the stack, de is already correct
	
	jp _Move_Loop_fixstack

_Move_Action_Save:
	push bc
		bcall(_ClrFrontBuffers)
	pop bc
	ld hl,(reuben_maxhp)
	ld (reuben_hp),hl
	ld a,(reuben_maxmp)
	ld (reuben_mp),a
	ld a,(TileMapData)
	ld (reuben_map),a
	
	call _Move_Draw_Reuben
	push bc
		call Sleep_med
		call Update
		bcall(_ClrFrontBuffers)
		call Sleep_short
		bcall(_Save)
	pop bc
	call _Move_Draw_Reuben
	call Sleep_short
	doSpeech_real(string_save)
	jp _Move_Loop_fixstack


_MoveItem:
	ld a,$ff
	out (1),a
	ld a,%10111110
	out (1),a
	
	call _MoveAction_entry
	jr {+1@}
_MoveItem_check_fixstack:
	ld sp,(moveStackPointer)
@:
	; if we are still here then we didn't interact with anything
	
	ld a,(reuben_curitem)
	or a
	jp z,_Move_Loop
	cp item_hookshot
	jp c,_MoveItem_Bottle
	jp z,_MoveItem_Hookshot
	cp item_bomb
	jp z,_MoveItem_Bomb
	jp _Move_Loop ; just to make sure

_Move_Grab_Tile_To_Sprite_Positions:
	ld a,e ; load the tilemap position
	
	ld c,$FF ; devide by 12 and store in c
	ld b,12
	inc c
	sub b
	jr nc,$-2
	
	add a,b ; xpos, mod 12
	add a,a
	add a,a
	add a,a
	ld b,a
	
	ld a,c
	add a,a
	add a,a
	add a,a
	ld c,a
	
	ret
_Move_Grab_Tile:
;INPUT: d = x offset
;; e = y offset
;; bc = positions
;Returns: a = tile
;; de = tile in map
;; hl = tile pointer
; preserves bc
	;push hl
	
	ld h,b
	ld l,c
	
	ld a,d ; calc x offset
	add a,h ; add current xpos
	srl a
	srl a
	srl a
	ld d,a ; save back
	
	
	ld a,e ; calc y offset
	add a,l ; add current ypos
	srl a
	srl a
	srl a
	ld e,a ; save back (needed for multiplying with 12)
	add a,a ; times 12
	add a,e
	add a,a
	add a,a
	
	add a,d ; add the x offset
	
	ld e,a ; load into de
	ld d,0
	
	
	ld b,h ; restore bc
	ld c,l
	
	ld hl,TileMapData+tilemaps_header_size ; header offset
	add hl,de ; add the offset
	
	
	ld a,(hl) ; load the tile
	;pop hl
	ret

_Move_Exit_Down:
	ld hl,TileMapData ; load new map
	ld a,(hl)
	ld c,tilemaps_width ; we need to set c to 0 anyways
	add a,c
	ld (hl),a
	push bc
		call slideDown
	pop bc
	ld c,0 ; set c again
	xor a
	ret
_Move_Exit_Left:
	ld hl,TileMapData ; load new map
	dec (hl)
	push bc
		call slideLeft
	pop bc
	ld b,88 ; set b again
	xor a
	ret
_Move_Exit_Right:
	ld hl,TileMapData ; load new map
	inc (hl)
	push bc
		call slideRight
	pop bc
	ld b,0 ; set b again
	xor a
	ret
_Move_Exit_Up:
	ld hl,TileMapData ; load new map
	ld a,(hl)
	ld c,tilemaps_width ; we need to set c to 56 anyways
	sub c
	ld (hl),a
	push bc
		call slideUp
	pop bc
	ld c,56 ; set c again
	xor a
	ret

_Move_Exit_Dialog_Line:
	ld a,%01111111
	ld (ix),a
	ld (hl),a
	inc ix
	inc hl
	ld a,$ff
	ld b,2
	-:
		ld (ix),a
		ld (hl),a
		inc ix
		inc hl
		djnz {-}
	ld a,%11111110
	ld (ix),a
	ld (hl),a
	ret
_Move_Exit_Dialog_drawchar:
	push bc
		ld a,b
		add a,a
		add a,b
		add a,a
		add a,a
		ld b,35
		add a,b
		
		ld b,a
		ld c,34
		
		ld a,bigsprite_MoveExit_Cursor
		ld ix,frontBuffer1
		ld iy,frontBuffer2
		bcall(_PutBigSpriteXOR)
	pop bc
	ret

_Move_Exit_Dialog:
	push bc
		call Wait_Key_Release
		ld ix,frontBuffer1+(24*12)+4
		ld hl,frontBuffer2+(24*12)+4
		ld de,12-4+1
		call _Move_Exit_Dialog_Line
		add ix,de
		add hl,de
		ld b,14
		-:
			ld a,%10000000
			ld (ix),a
			ld (hl),a
			inc ix
			inc hl
			xor a
			
			ld c,2
			--:
				ld (ix),a
				ld (hl),a
				inc ix
				inc hl
				dec c
				jr nz,{--}
			
			ld a,%00000001
			ld (ix),a
			ld (hl),a
			add ix,de
			add hl,de
			djnz {-}
		
		call _Move_Exit_Dialog_Line
		ld bc,getCoordinates(39,26)
		ld hl,string_exitDialog
		ld a,1
		bcall(_Text_entry)
		ld bc,getCoordinates(38,33)
		ld hl,string_exitYN
		ld a,1
		bcall(_Text_entry)
		
		ld b,0
		_MoveExit_Loop:
			call _Move_Exit_Dialog_drawchar
			call Wait_Key_Input
			call Wait_Key_Release
			
			ld c,a
			call _Move_Exit_Dialog_drawchar
			
			bit 1,c
			jr z,{+}
			bit 2,c
			jr nz,{++}
			+:
				ld a,1
				xor b
				ld b,a
			++:
			
			bit 5,c
			jr nz,{+}
				ld a,b
				or a
				jr z,_MoveExit_noexit
				ld sp,(moveStackPointer)
				ld a,1
				ret
			+:
			
			
			bit 7,c
			jr nz,_MoveExit_Loop
_MoveExit_noexit:
	call Update
	pop bc
	call _Move_Draw_Reuben
	jp _Move_Loop_fixstack


slideLeft:
	call _slide_setup
	
	ld b,12
	_slideLeft_loop:
		call Sleep_short
		ld e,b
		push bc
			push de
				ld hl,backBuffer1+(12*64)-2
				ld de,backBuffer1+(12*64)-1
				ld bc,(12*64)-1
				lddr
				ld hl,backBuffer2+(12*64)-2
				ld de,backBuffer2+(12*64)-1
				ld bc,(12*64)-1
				lddr
			pop de
			ld d,0
			ld hl,TileMapData+2-1+96-12 ; minus one as de is always one to high
			add hl,de
			ld b,8
				@:
					push bc
						push hl
							dec b
							ld a,b
							add a,a
							add a,b
							add a,a
							add a,a
							ld l,a
							ld h,0
							add hl,hl
							add hl,hl
							add hl,hl
							ex de,hl
						pop hl
						
						ld a,(hl)
						push hl
							ld h,0
							ld l,a
							add hl,hl
							add hl,hl
							add hl,hl
							add hl,hl
							push de
								ld de,sprites
								add hl,de
							pop de
							ld ix,backBuffer1
							ld iy,backBuffer2
							bcall(_graySpriteOverwritealigned)
							
						pop hl
						ld de,12
						or a
						sbc hl,de
					pop bc
					djnz {-1@}
			call Update
		pop bc
		djnz _slideLeft_loop
	ret

slideRight:
	call _slide_setup
	
	ld b,12
	_slideRight_loop:
		call Sleep_short
		ld a,12
		sub b
		ld e,a
		push bc
			push de
				ld hl,backBuffer1+1
				ld de,backBuffer1
				ld bc,(12*64)-1
				ldir
				ld hl,backBuffer2+1
				ld de,backBuffer2
				ld bc,(12*64)-1
				ldir
			pop de
			ld d,0
			
			ld hl,TileMapData+2+96-12
			add hl,de
			ld b,8
				@:
					push bc
						push hl
							dec b
							ld a,b
							add a,a
							add a,b
							add a,a
							add a,a
							ld l,a
							ld h,0
							add hl,hl
							add hl,hl
							add hl,hl
							ld de,11
							add hl,de
							ex de,hl
						pop hl
						
						ld a,(hl)
						push hl
							ld h,0
							ld l,a
							add hl,hl
							add hl,hl
							add hl,hl
							add hl,hl
							push de
								ld de,sprites
								add hl,de
							pop de
							ld ix,backBuffer1
							ld iy,backBuffer2
							bcall(_graySpriteOverwritealigned)
							
						pop hl
						ld de,12
						or a
						sbc hl,de
					pop bc
					djnz {-1@}
			call Update
		pop bc
		djnz _slideRight_loop
	ret

slideUp:
	call _slide_setup
	
	ld b,8
	_slideUp_loop:
		call Sleep_short
		ld e,b
		push bc
			push de
				ld hl,backBuffer1+(12*64)-1-(8*12)
				ld de,backBuffer1+(12*64)-1
				ld bc,(12*64)-(8*12)
				lddr
				ld hl,backBuffer2+(12*64)-1-(8*12)
				ld de,backBuffer2+(12*64)-1
				ld bc,(12*64)-(8*12)
				lddr
			pop de
			ld d,0
			ld h,0
			ld l,e
			add hl,hl
			add hl,de
			add hl,hl
			add hl,hl
			ld de,TileMapData+2-12 ; hl will always be one too large
			add hl,de
			ld de,0
			ld b,12
			@:
				push bc
					ld a,(hl)
					push hl
					push de
						ld h,0
						ld l,a
						add hl,hl
						add hl,hl
						add hl,hl
						add hl,hl
						push de
							ld de,sprites
							add hl,de
						pop de
						ld ix,backBuffer1
						ld iy,backBuffer2
						bcall(_graySpriteOverwritealigned)
					pop de
					pop hl
				
					inc hl
					inc de
				pop bc
				djnz {-1@}
			call Update
		pop bc
		djnz _slideUp_loop
	ret

slideDown:
	call _slide_setup
	
	ld b,8
	_slideDown_loop:
		call Sleep_short
		ld a,8
		sub b
		ld e,a
		push bc
			push de
				ld hl,backBuffer1+(8*12)
				ld de,backBuffer1
				ld bc,(12*64)-(8*12)
				ldir
				ld hl,backBuffer2+(8*12)
				ld de,backBuffer2
				ld bc,(12*64)-(8*12)
				ldir
			pop de
			ld d,0
			ld h,0
			ld l,e
			add hl,hl
			add hl,de
			add hl,hl
			add hl,hl
			ld de,TileMapData+2+11
			add hl,de
			ld de,12*64-(7*12)-1
			ld b,12
			@:
				push bc
					ld a,(hl)
					push hl
					push de
						ld h,0
						ld l,a
						add hl,hl
						add hl,hl
						add hl,hl
						add hl,hl
						push de
							ld de,sprites
							add hl,de
						pop de
						ld ix,backBuffer1
						ld iy,backBuffer2
						bcall(_graySpriteOverwritealigned)
					pop de
					pop hl
				
					dec hl
					dec de
				pop bc
				djnz {-1@}
			call Update
		pop bc
		djnz _slideDown_loop
	ret

_Move_Switchworld:
; we call this, however it acts quite differently as it sets the SP to the entry of the move-engine
; call _Move_Switchworld
; .db world
; .db tilemap
; .dw getCoordinates(x,y)
	pop hl
	ld a,(hl)
	inc hl
	ld (reuben_world),a
	ld a,(hl)
	inc hl
	ld (TileMapData),a
	ld c,(hl)
	inc hl
	ld b,(hl)
	
	push bc
		;ld hl,frontBuffer1+12*8*8-1
		;ld de,frontBuffer1+12*8*8-2
		;ld ix,frontBuffer2
		;ld iy,frontBuffer2+1
		;xor a
		;ld (hl),a
		;ld (ix),a
		;call _Move_Switchworld_anim
		
		bcall(_LoadTileMap)
		bcall(_DrawTileMap)
		
		ld hl,backBuffer1+12*8*8-1
		ld de,frontBuffer1+12*8*8-1
		ld ix,backBuffer2
		ld iy,frontBuffer2
		ld b,64
		@:
			push bc
				ld bc,12
				lddr
				
				; These ex things change ~two bytes compared to using stack for this
				
				; iy -> de
				; de -> hl
				; hl -> stack
				; stack -> iy
				ex (sp),iy
				ex (sp),hl
				ex de,hl
				
				; ix -> hl
				; hl -> stack
				; stack -> ix
				ex (sp),ix
				ex (sp),hl
				
				ld bc,12
				ldir
				
				ex (sp),hl
				ex (sp),ix
				
				ex de,hl
				ex (sp),hl
				ex (sp),iy
				
				call Sleep_veryshort
			pop bc
			djnz {-1@}
	pop bc
	ld sp,(moveStackPointer)
	xor a
	ret

_slide_setup:
	bcall(_LoadTileMap)
	jp RevUpdate

_Move_ReloadMap:
	push bc
		bcall(_LoadTileMap)
		bcall(_DrawTileMap)
		call Update
	pop bc
	jp _Move_Draw_Reuben

_Move_Switchportal:
; INPUT:
; hl: portal coordinates (for animation)
; d: new world
; e: new tilemap
; bc: new positions
	push bc
		push de
			ld ix,frontBuffer1
			ld iy,frontBuffer2+11
			ld b,24
			-:
				ld a,$0F
				bit 0,b
				jr z,{+}
				ld a,$F0
				+:
				push ix
				push iy
					push af
					ld c,64
					--:
						push bc
							ld d,h
							ld e,l
							
							ld b,a
							ex (sp),hl
							
							; hl are now the loop iterators
							; de are the positions
							
							; check for the left side
							ld a,h
							cp d
							jr nc,{+}
							
							; check for the right side
							add a,6
							cp d
							jr c,{+}
							
							; check for the top
							ld a,l
							cp e
							jr nc,{+}
							
							; check for the bottom
							add a,4*8
							cp e
							jr nc,{++}
							
							+:
							ld a,(ix)
							and b
							ld (ix),a
							
							++:
							ld de,12
							add ix,de
							ld a,b
							
							ex (sp),hl
						pop bc
						dec c
						jr nz,{--}
					pop af
					cpl
					ld c,64
					--:
						push bc
							ld d,h
							ld e,l
							
							ld b,a
							ex (sp),hl
							
							; left side
							ld a,25
							sub h
							cp d
							jr nc,{+}
							
							; right side
							add a,6
							cp d
							jr c,{+}
							
							; top side
							ld a,l
							cp e
							jr nc,{+}
							
							; bottom side
							add a,4*8
							cp e
							jr nc,{++}
							
							+:
							ld a,(iy)
							and b
							ld (iy),a
							
							++:
							ld de,12
							add iy,de
							ld a,b
							ex (sp),hl
						pop bc
						dec c
						jr nz,{--}
					call Sleep_short
				pop iy
				pop ix
				bit 0,b
				jr nz,{+}
				djnz {-}
				+:
				inc ix
				dec iy
				djnz {-}
			ld ix,frontBuffer1
			ld iy,frontBuffer2
			srl h
			dec h
			ld a,12
			sub h
			ld d,b ; b is zero as it is after djnz loop, one byte smaller
			ld e,a
			add ix,de
			add iy,de
			ld de,12
			ld c,%10000001
			call _Move_Switchportal_vline_or
			ld c,%01000010
			call _Move_Switchportal_vline_or
			ld c,%00100100
			call _Move_Switchportal_vline_or
			ld c,%00011000
			call _Move_Switchportal_vline_or
			
			ld a,(GSContrast)
			or %11000000
			-:
				ld c,%10000001
				call _Move_Switchportal_vline_xor
				ld c,%01000010
				call _Move_Switchportal_vline_xor
				ld c,%00100100
				call _Move_Switchportal_vline_xor
				ld c,%00011000
				call _Move_Switchportal_vline_xor
				cp %11011000
				jr c,{-}
			ld a,%11000000
			out ($10),a
		pop hl
		ld a,h
		ld (reuben_world),a
		ld a,l
		ld (TileMapData),a
		
		bcall(_LoadTileMap)
		bcall(_DrawTileMap)
		call Update
		bcall(_fade_from_white)
	pop bc
	ld sp,(moveStackPointer)
	ld a,2
	ld (moveDirection),a
	xor a
	ret
_Move_Switchportal_vline_or:
	push ix
	push iy
		ld a,64+16
		sub l
		ld b,a
		-:
			ld a,(ix)
			or c
			ld (ix),a
			ld a,(iy)
			or c
			ld (iy),a
			add ix,de
			add iy,de
			djnz {-}
	pop iy
	pop ix
	jp Sleep_med
_Move_Switchportal_vline_xor:
	dec a
	out ($10),a
	push af
	push ix
	push iy
		ld a,64+16
		sub l
		ld b,a
		-:
			ld a,(ix)
			xor c
			ld (ix),a
			ld a,(iy)
			xor c
			ld (iy),a
			add ix,de
			add iy,de
			djnz {-}
	pop iy
	pop ix
	call Sleep_med
	pop af
	ret

ReubenSprites:
	; walk sprites
	.db $38,$FF,$FF,$7C,$FF,$C7,$FE,$FF,$83,$FE,$FF,$83,$7C,$FF,$EF,$7E,$FF,$D7,$FF,$FD,$81,$FE,$E7,$FF
	.db $1C,$FF,$FF,$3E,$FF,$E3,$7F,$FF,$C1,$7F,$FF,$C1,$3E,$FF,$F7,$7E,$FF,$EB,$FF,$BF,$81,$7F,$E7,$FF
	.db $3C,$FF,$FF,$7E,$FF,$C3,$FF,$FF,$8F,$FE,$FB,$BB,$7F,$E9,$E9,$FE,$FB,$D3,$FC,$F7,$97,$FC,$E7,$FF
	.db $3C,$FF,$FF,$7E,$FF,$C3,$FF,$FF,$8F,$FE,$FB,$BB,$7F,$E9,$E9,$FE,$F3,$D3,$FC,$EF,$AF,$F8,$CF,$FF
	.db $1C,$FF,$FF,$3E,$FF,$E3,$7F,$FF,$DD,$7F,$F7,$F7,$7F,$D5,$D5,$7F,$E3,$A2,$FF,$BD,$A1,$FF,$E7,$FF
	.db $38,$FF,$FF,$7C,$FF,$C7,$FE,$FF,$BB,$FE,$EF,$EF,$FE,$AB,$AB,$FE,$C7,$45,$FF,$BD,$85,$FF,$E7,$FF
	.db $3C,$FF,$FF,$7E,$FF,$C3,$FF,$FF,$F1,$7F,$DF,$DD,$FE,$97,$97,$7F,$CF,$CB,$3F,$F7,$F5,$1F,$F3,$FF
	.db $3C,$FF,$FF,$7E,$FF,$C3,$FF,$FF,$F1,$7F,$DF,$DD,$FE,$97,$97,$7F,$DF,$CB,$3F,$EF,$E9,$3F,$E7,$FF

ReubenSpritesSwim:
	.db %00111000,%11111111,%11111111
	.db %01111100,%11111111,%11000111
	.db %11111110,%11111111,%10000011
	.db %11111110,%11111111,%10000011
	.db %01111100,%11111111,%11101111
	.db %00010000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	.db %00011100,%11111111,%11111111
	.db %00111110,%11111111,%11100011
	.db %01111111,%11111111,%11000001
	.db %01111111,%11111111,%11000001
	.db %00111110,%11111111,%11110111
	.db %00001000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	
	.db %00111100,%11111111,%11111111
	.db %01111110,%11111111,%11000011
	.db %11111111,%11111111,%10001111
	.db %11111110,%11111011,%10111011
	.db %01111111,%11101001,%11101001
	.db %00011110,%11110011,%11110011
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	.db %00000000,%11111111,%11111111
	.db %00111100,%11111111,%11111111
	.db %01111110,%11111111,%11000011
	.db %11111111,%11111111,%10001111
	.db %11111110,%11111011,%10111011
	.db %01111111,%11101001,%11101001
	.db %00011110,%11110011,%11110011
	.db %00000000,%11111111,%11111111
	
	
	.db %00111000,%11111111,%11111111
	.db %01111100,%11111111,%11000111
	.db %11111110,%11111111,%10111011
	.db %11111110,%11101111,%11101111
	.db %11111110,%10101011,%10101011
	.db %01111100,%10000011,%10000011
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	.db %00011100,%11111111,%11111111
	.db %00111110,%11111111,%11100011
	.db %01111111,%11111111,%11011101
	.db %01111111,%11110111,%11110111
	.db %01111111,%11010101,%11010101
	.db %00111110,%11000001,%11000001
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	
	.db %00111100,%11111111,%11111111
	.db %01111110,%11111111,%11000011
	.db %11111111,%11111111,%11110001
	.db %01111111,%11011111,%11011101
	.db %11111110,%10010111,%10010111
	.db %01111000,%11001111,%11001111
	.db %00000000,%11111111,%11111111
	.db %00000000,%11111111,%11111111
	
	.db %00000000,%11111111,%11111111
	.db %00111100,%11111111,%11111111
	.db %01111110,%11111111,%11000011
	.db %11111111,%11111111,%11110001
	.db %01111111,%11011111,%11011101
	.db %11111110,%10010111,%10010111
	.db %01111000,%11001111,%11001111
	.db %00000000,%11111111,%11111111
	
