.define script_stop 0
.define script_load_world 1 ; takes: world ID (byte), map ID (byte)
.define script_load_map 2 ; takes: map ID (byte)
.define script_fade_to_white 3
.define script_fade_from_white 4
.define script_draw_tilemap 5 
.define script_sleep 6 ; takes: time (byte)
.define script_shake_screen 7
.define script_overwrite_sprite 8 ; takes: positions (singleCoordinates) (byte), sprite ID (byte) ; loops until $ff
.define script_draw_reuben 9
.define script_return_map 10
.define script_fade_return_map 11
.define script_speech 12 ; takes: pointer (two bytes)
.define script_reuben_move_left_shake_screen 13
.define script_draw_only_tilemap 14

.define singleCoordinates(x,y) (x*16) + y

fade_to_white:
	ld a,(GSContrast)
	or %11000000
	-:
		dec a
		out ($10),a
		push af
			ld a,1
			bcall(_Sleep)
		pop af
		cp %11011000
		jr nz,{-}
	ld a,%11000000
	out ($10),a
	ret
fade_from_white:
	push bc
		ld b,%00011000
		-:
			inc b
			ld a,b
			or %11000000
			out ($10),a
			ld a,1
			bcall(_Sleep)
			ld de,(GSContrast) ; we just need e but can't destroy hl
			ld a,b
			cp e
			jr nz,{-}
	pop bc
	ret

_Script_exit:
	pop bc
	ret

Script:
; hl - pointer
; destroys: all! (except bc)
; preserves: bc
	ld a,(reuben_world)
	ld (tmp6),a
	push bc
	push hl
		ld hl,TileMapData
		ld de,decompressArea
		ld bc,96 + tilemaps_header_size
		ldir
		ld hl,eventTiles
		ld de,decompressArea + 96 + tilemaps_header_size
		ld bc,108
		ldir
	pop hl
	pop bc
_Script_nosave:
	push bc
_Script_Loop:
	ld a,(hl)
	inc hl
	
	or a
	jr z,_Script_exit ; script_stop
	
	dec a
	jr nz,{+}
	; script_load_world
	ld a,(hl)
	inc hl
	ld (reuben_world),a
	jr {++}
+:
	dec a
	jr nz,{+}
	++:
	; script_load_map
	ld a,(hl)
	inc hl
	ld (TileMapData),a
	jr _Script_Loop
+:
	dec a
	jr nz,{+}
	; script_fade_to_white
	call fade_to_white
	jr _Script_Loop
+:
	dec a
	jr nz,{+}
	; script_fade_from_white
	call fade_from_white
	jr _Script_Loop
+:
	dec a
	jr nz,{+}
	; script_draw_tilemap
	push hl
		bcall(_LoadTileMap)
		bcall(_DrawTileMap)
		bcall(_Update)
	pop hl
---:
	jr _Script_Loop
+:
	dec a
	jr nz,{+}
	; script_sleep
	ld a,(hl)
	inc hl
	bcall(_Sleep)
	jr _Script_Loop
+:
	dec a
	jr nz,{+}
	; script_shake_screen
	ld b,4
	-:
		ld a,$7C
		out ($10),a
		ld a,4
		bcall(_Sleep)
		ld a,$40
		out ($10),a
		ld a,4
		bcall(_Sleep)
		djnz {-}
	jr {---}
+:
	dec a
	jr nz,{+}
	; script_overwrite_sprite
	-:
		ld a,(hl)
		and $0F
		add a,a
		ld d,a
		add a,a
		add a,a
		ld c,a
		
		add a,d
		add a,d
		ld d,a
		
		ld a,(hl)
		rra
		rra
		rra
		rra
		and $0F
		ld b,a
		add a,d
		ld d,0
		ld e,a
		ld a,b
		add a,a
		add a,a
		add a,a
		ld b,a
		inc hl
		
		
		ld a,(hl)
		inc hl
		push hl
			ld hl,TileMapData+tilemaps_header_size
			add hl,de
			ld (hl),a
			bcall(_graySpriteOverwrite_bothBuffers_by_id)
		pop hl
		ld a,(hl)
		inc a
		jr nz,{-}
		inc hl
		jr {---}
+:
	dec a
	jr nz,{+}
	; script_draw_reuben
	push hl
		ld hl,reuben_x
		ld b,(hl)
		inc hl
		ld c,(hl)
		bcall(__Move_Draw_Reuben)
	pop hl
----:
	jr {---}
+:
	dec a
	jr nz,{+}
	; script_return_map
	ld a,(tmp6)
	ld (reuben_world),a
	
	push bc
	push hl
		ld hl,decompressArea
		ld de,TileMapData
		ld bc,96 + tilemaps_header_size
		ldir
		ld hl,decompressArea + 96 + tilemaps_header_size
		ld de,eventTiles
		ld bc,108
		ldir
	pop hl
	pop bc
	jr {----}
+:
	dec a
	jr nz,{+}
	; script_fade_return_map
	push hl
		ld hl,_script_fade_return_map
		call _Script_nosave
	pop hl
	jr {----}
+:
	dec a
	jr nz,{+}
	; script_speech
	push hl
		ld e,(hl)
		inc hl
		ld d,(hl)
		ex de,hl
		bcall(__SpeechMove_entry)
	pop hl
	jr {----}
+:
	dec a
	jr nz,{+}
	; script_reuben_move_left_shake_screen
	pop bc
	push hl
		ld a,$7C
		-:
			out ($10),a
			push af
				bcall(__Move_Draw_Reuben_With_Erase)
				ld a,4
				bcall(_Sleep)
			pop af
			xor %00111100
			djnz {-}
		bcall(__Move_Draw_Reuben_With_Erase)
		ld a,4
		bcall(_Sleep)
		ld a,$40
		out ($10),a
	pop hl
	push bc
	jr {----}
+:
	dec a
	jr nz,{+}
	; script_draw_only_tilemap
	push hl
		bcall(_DrawTileMap)
		bcall(_Update)
	pop hl
	jr {----}
+:
	jr {----}

_script_fade_return_map:
	.db script_fade_to_white
	.db script_return_map
	.db script_draw_only_tilemap
	.db script_draw_reuben
	.db script_fade_from_white
	.db script_stop

script_destroy_lake_tilemap_349:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_world,world_overworld,tilemap_107
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(1,4),sprite_101
		.db singleCoordinates(2,4),sprite_125
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(2,3),sprite_101
		.db singleCoordinates(0,4),sprite_108
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(0,4),sprite_blank
		.db singleCoordinates(1,4),sprite_108
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(1,4),sprite_blank
		.db singleCoordinates(2,4),sprite_112
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(2,4),sprite_blank
		.db singleCoordinates(2,3),sprite_112
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(2,3),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(8,2),sprite_103
	
		.db singleCoordinates(9,0),sprite_118
		.db singleCoordinates(10,0),sprite_101
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,0),sprite_118
		.db singleCoordinates(9,0),sprite_101
		.db singleCoordinates(10,0),sprite_104
		.db singleCoordinates(9,1),sprite_118
		.db singleCoordinates(10,1),sprite_101
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,0),sprite_104
		.db singleCoordinates(9,0),sprite_203
		.db singleCoordinates(10,0),sprite_203
		.db singleCoordinates(8,1),sprite_118
		.db singleCoordinates(9,1),sprite_104
		.db singleCoordinates(10,1),sprite_203
		.db singleCoordinates(9,2),sprite_118
		.db singleCoordinates(10,2),sprite_104
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,0),sprite_203
		.db singleCoordinates(8,1),sprite_104
		.db singleCoordinates(9,1),sprite_203
		.db singleCoordinates(8,2),sprite_101
		.db singleCoordinates(9,2),sprite_104
		.db singleCoordinates(10,2),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,1),sprite_203
		.db singleCoordinates(8,2),sprite_104
		.db singleCoordinates(9,2),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	
	
	.db script_stop


script_forstDungeon_secret1_tilemap_50:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_51
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,2),sprite_6
		.db singleCoordinates(10,2),sprite_4
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,2),sprite_6
		.db singleCoordinates(9,2),sprite_blank
		.db singleCoordinates(9,3),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,3),sprite_17
		.db singleCoordinates(9,3),sprite_blank
		.db singleCoordinates(10,3),sprite_17
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,4),sprite_6
		.db singleCoordinates(9,5),sprite_41
		.db singleCoordinates(10,4),sprite_27
		.db singleCoordinates(10,5),sprite_39
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,4),sprite_29
		.db singleCoordinates(8,5),sprite_41
		.db singleCoordinates(9,4),sprite_blank
		.db singleCoordinates(9,5),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	
	.db script_stop

script_forstDungeon_secret2_tilemap_55:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_56
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,4),sprite_27
		.db singleCoordinates(5,5),sprite_39
		.db singleCoordinates(5,6),sprite_blank
		.db singleCoordinates(6,4),sprite_28
		.db singleCoordinates(6,5),sprite_40
		.db singleCoordinates(6,6),sprite_blank
		.db singleCoordinates(7,5),sprite_27
		.db singleCoordinates(8,5),sprite_28
		.db singleCoordinates(7,6),sprite_39
		.db singleCoordinates(8,6),sprite_40
		.db singleCoordinates(9,6),sprite_15
		.db singleCoordinates(7,7),sprite_5
		.db singleCoordinates(8,7),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(7,4),sprite_28
		.db singleCoordinates(7,5),sprite_40
		.db singleCoordinates(7,6),sprite_blank
		.db singleCoordinates(8,4),sprite_28
		.db singleCoordinates(8,5),sprite_40
		.db singleCoordinates(8,6),sprite_blank
		.db singleCoordinates(9,5),sprite_27
		.db singleCoordinates(10,5),sprite_28
		.db singleCoordinates(9,6),sprite_39
		.db singleCoordinates(10,6),sprite_40
		.db singleCoordinates(11,6),sprite_15
		.db singleCoordinates(9,7),sprite_5
		.db singleCoordinates(10,7),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,4),sprite_28
		.db singleCoordinates(9,5),sprite_40
		.db singleCoordinates(9,6),sprite_blank
		.db singleCoordinates(10,4),sprite_28
		.db singleCoordinates(10,5),sprite_40
		.db singleCoordinates(10,6),sprite_blank
		.db singleCoordinates(11,5),sprite_27
		.db singleCoordinates(11,6),sprite_39
		.db singleCoordinates(11,7),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(11,4),sprite_28
		.db singleCoordinates(11,5),sprite_40
		.db singleCoordinates(11,6),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_aerilon_castle_1:
	.db script_shake_screen
	.db script_shake_screen

	.db script_fade_to_white
	.db script_load_world,world_aerilon_castle,tilemap_256
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_35
		.db singleCoordinates(7,7),sprite_23
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(7,7),sprite_205
		.db singleCoordinates(8,7),sprite_23
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	.db script_stop

script_aerilon_castle_2:
	.db script_overwrite_sprite
		.db singleCoordinates(5,0),sprite_205
		.db $ff
	.db script_sleep,10
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,0),sprite_205
		.db $ff
	.db script_sleep,10
	
	.db script_overwrite_sprite
		.db singleCoordinates(7,0),sprite_205
		.db $ff
	.db script_sleep,10
	
	.db script_stop

script_dungeonBombs_1:
	.db script_shake_screen
	.db script_shake_screen

	.db script_fade_to_white
	.db script_load_map,tilemap_158
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(7,7),sprite_9
		.db singleCoordinates(8,7),sprite_7
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_32
		.db singleCoordinates(7,7),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(8,7),sprite_203
		.db singleCoordinates(9,7),sprite_7
		.db $ff
	.db script_shake_screen
	
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	.db script_stop

script_dungeonBombs_2:
	.db script_shake_screen
	.db script_shake_screen

	.db script_fade_to_white
	.db script_load_map,tilemap_160
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen

	.db script_overwrite_sprite
		.db singleCoordinates(5,3),sprite_203
		.db $ff
	.db script_shake_screen

	.db script_overwrite_sprite
		.db singleCoordinates(5,4),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	.db script_stop

script_past_king_bridge:
	.db script_speech
		.dw string_past_king_1
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(0,3),sprite_127
		.db $ff
	.db script_shake_screen
	.db script_reuben_move_left_shake_screen
	
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(4,3),sprite_95
		.db $ff
	
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(3,3),sprite_19
		.db $ff
	
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(2,3),sprite_19
		.db $ff
	
	.db script_shake_screen
	.db script_overwrite_sprite
		.db singleCoordinates(1,3),sprite_96
		.db $ff
	
	.db script_stop

script_find_portalpiece:
	.db script_overwrite_sprite
		.db singleCoordinates(5,2),sprite_blank
		.db $ff
	.db script_sleep,32

	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_7
		.db $ff
	.db script_sleep,32

	.db script_overwrite_sprite
		.db singleCoordinates(5,7),sprite_46
		.db $ff
	.db script_sleep,32

	.db script_overwrite_sprite
		.db singleCoordinates(4,7),sprite_9
		.db $ff
	.db script_stop

script_open_bottle4_path:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_world,world_overworld,tilemap_207
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(10,1),sprite_blank
		.db singleCoordinates(11,1),sprite_blank
		.db singleCoordinates(10,2),sprite_4
		.db singleCoordinates(11,2),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(10,2),sprite_blank
		.db singleCoordinates(11,2),sprite_126
		.db singleCoordinates(10,3),sprite_5
		.db singleCoordinates(11,3),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,3),sprite_blank
		.db singleCoordinates(10,3),sprite_blank
		.db singleCoordinates(11,3),sprite_blank
		.db singleCoordinates(9,4),sprite_4
		.db singleCoordinates(10,4),sprite_5
		.db singleCoordinates(11,4),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,4),sprite_blank
		.db singleCoordinates(10,4),sprite_blank
		.db singleCoordinates(11,4),sprite_blank
		.db singleCoordinates(9,5),sprite_5
		.db singleCoordinates(10,5),sprite_5
		.db singleCoordinates(11,5),sprite_5
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,5),sprite_blank
		.db singleCoordinates(9,5),sprite_blank
		.db singleCoordinates(10,5),sprite_blank
		.db singleCoordinates(11,5),sprite_blank
		.db singleCoordinates(8,6),sprite_4
		.db singleCoordinates(9,6),sprite_6
		.db singleCoordinates(10,6),sprite_blank
		.db singleCoordinates(11,6),sprite_126
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,6),sprite_blank
		.db singleCoordinates(9,6),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(8,7),sprite_blank
		.db singleCoordinates(9,7),sprite_126
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_swim_dungeon_gate_open:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_320
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,1),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(4,1),sprite_203
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_dungeon_blocks_pregates:
	.db script_fade_to_white
	.db script_load_map,tilemap_140
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32
		
	.db script_stop

script_dungeon_hookshot_gate_1:
	.db script_fade_to_white
	.db script_load_map,tilemap_387
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32
	
	.db script_stop

script_dungeon_hookshot_gate_2:
	.db script_fade_to_white
	.db script_load_map,tilemap_396
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32
	
	.db script_stop

script_run_fade_return_map_wait:
	.db script_draw_tilemap
	.db script_sleep,32
	.db script_fade_return_map
	.db script_stop

script_sandcastle:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_world,world_overworld,tilemap_445
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,5),sprite_23
		.db singleCoordinates(6,5),sprite_35
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,4),sprite_23
		.db singleCoordinates(6,4),sprite_35
		.db singleCoordinates(5,5),sprite_47
		.db singleCoordinates(6,5),sprite_59
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,3),sprite_23
		.db singleCoordinates(6,3),sprite_35
		.db singleCoordinates(5,4),sprite_47
		.db singleCoordinates(6,4),sprite_59
		.db singleCoordinates(5,5),sprite_25
		.db singleCoordinates(6,5),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,2),sprite_23
		.db singleCoordinates(6,2),sprite_35
		.db singleCoordinates(5,3),sprite_47
		.db singleCoordinates(6,3),sprite_59
		.db singleCoordinates(5,4),sprite_25
		.db singleCoordinates(6,4),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,1),sprite_23
		.db singleCoordinates(6,1),sprite_35
		.db singleCoordinates(5,2),sprite_47
		.db singleCoordinates(6,2),sprite_59
		.db singleCoordinates(5,3),sprite_25
		.db singleCoordinates(6,3),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,0),sprite_23
		.db singleCoordinates(6,0),sprite_35
		.db singleCoordinates(5,1),sprite_47
		.db singleCoordinates(6,1),sprite_59
		.db singleCoordinates(5,2),sprite_25
		.db singleCoordinates(6,2),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_446
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,7),sprite_23
		.db singleCoordinates(6,7),sprite_35
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,6),sprite_23
		.db singleCoordinates(6,6),sprite_35
		.db singleCoordinates(5,7),sprite_47
		.db singleCoordinates(6,7),sprite_59
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,5),sprite_23
		.db singleCoordinates(6,5),sprite_35
		.db singleCoordinates(5,6),sprite_47
		.db singleCoordinates(6,6),sprite_59
		.db singleCoordinates(5,7),sprite_25
		.db singleCoordinates(6,7),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,4),sprite_23
		.db singleCoordinates(6,4),sprite_35
		.db singleCoordinates(5,5),sprite_47
		.db singleCoordinates(6,5),sprite_59
		.db singleCoordinates(5,6),sprite_25
		.db singleCoordinates(6,6),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,3),sprite_23
		.db singleCoordinates(6,3),sprite_35
		.db singleCoordinates(5,4),sprite_47
		.db singleCoordinates(6,4),sprite_59
		.db singleCoordinates(5,5),sprite_25
		.db singleCoordinates(6,5),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,2),sprite_23
		.db singleCoordinates(6,2),sprite_35
		.db singleCoordinates(5,3),sprite_47
		.db singleCoordinates(6,3),sprite_59
		.db singleCoordinates(5,4),sprite_25
		.db singleCoordinates(6,4),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,1),sprite_23
		.db singleCoordinates(6,1),sprite_35
		.db singleCoordinates(5,2),sprite_47
		.db singleCoordinates(6,2),sprite_59
		.db singleCoordinates(5,3),sprite_25
		.db singleCoordinates(6,3),sprite_13
		
		.db singleCoordinates(3,7),sprite_23
		.db singleCoordinates(4,7),sprite_35
		.db singleCoordinates(7,7),sprite_23
		.db singleCoordinates(8,7),sprite_35
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,0),sprite_23
		.db singleCoordinates(6,0),sprite_35
		.db singleCoordinates(5,1),sprite_47
		.db singleCoordinates(6,1),sprite_59
		.db singleCoordinates(5,2),sprite_25
		.db singleCoordinates(6,2),sprite_13
		
		.db singleCoordinates(3,6),sprite_23
		.db singleCoordinates(4,6),sprite_35
		.db singleCoordinates(7,6),sprite_23
		.db singleCoordinates(8,6),sprite_35
		
		.db singleCoordinates(2,7),sprite_23
		.db singleCoordinates(3,7),sprite_47
		.db singleCoordinates(4,7),sprite_59
		.db singleCoordinates(7,7),sprite_47
		.db singleCoordinates(8,7),sprite_59
		.db singleCoordinates(9,7),sprite_35
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,0),sprite_47
		.db singleCoordinates(6,0),sprite_59
		.db singleCoordinates(5,1),sprite_25
		.db singleCoordinates(6,1),sprite_13
		
		.db singleCoordinates(3,5),sprite_23
		.db singleCoordinates(4,5),sprite_35
		.db singleCoordinates(7,5),sprite_23
		.db singleCoordinates(8,5),sprite_35
		
		.db singleCoordinates(2,6),sprite_23
		.db singleCoordinates(3,6),sprite_47
		.db singleCoordinates(4,6),sprite_59
		.db singleCoordinates(7,6),sprite_47
		.db singleCoordinates(8,6),sprite_59
		.db singleCoordinates(9,6),sprite_35
		
		.db singleCoordinates(1,7),sprite_23
		.db singleCoordinates(2,7),sprite_35
		.db singleCoordinates(3,7),sprite_25
		.db singleCoordinates(4,7),sprite_10
		.db singleCoordinates(5,7),sprite_10
		.db singleCoordinates(6,7),sprite_10
		.db singleCoordinates(7,7),sprite_10
		.db singleCoordinates(8,7),sprite_13
		.db singleCoordinates(9,7),sprite_23
		.db singleCoordinates(10,7),sprite_35
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,0),sprite_25
		.db singleCoordinates(6,0),sprite_13
		
		.db singleCoordinates(3,4),sprite_23
		.db singleCoordinates(4,4),sprite_35
		.db singleCoordinates(7,4),sprite_23
		.db singleCoordinates(8,4),sprite_35
		
		.db singleCoordinates(2,5),sprite_23
		.db singleCoordinates(3,5),sprite_47
		.db singleCoordinates(4,5),sprite_59
		.db singleCoordinates(7,5),sprite_47
		.db singleCoordinates(8,5),sprite_59
		.db singleCoordinates(9,5),sprite_35
		
		.db singleCoordinates(1,6),sprite_23
		.db singleCoordinates(2,6),sprite_35
		.db singleCoordinates(3,6),sprite_25
		.db singleCoordinates(4,6),sprite_10
		.db singleCoordinates(5,6),sprite_10
		.db singleCoordinates(6,6),sprite_10
		.db singleCoordinates(7,6),sprite_10
		.db singleCoordinates(8,6),sprite_13
		.db singleCoordinates(9,6),sprite_23
		.db singleCoordinates(10,6),sprite_35
		
		.db singleCoordinates(1,7),sprite_47
		.db singleCoordinates(2,7),sprite_59
		.db singleCoordinates(9,7),sprite_47
		.db singleCoordinates(10,7),sprite_59
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,3),sprite_23
		.db singleCoordinates(4,3),sprite_35
		.db singleCoordinates(7,3),sprite_23
		.db singleCoordinates(8,3),sprite_35
		
		.db singleCoordinates(2,4),sprite_23
		.db singleCoordinates(3,4),sprite_47
		.db singleCoordinates(4,4),sprite_59
		.db singleCoordinates(7,4),sprite_47
		.db singleCoordinates(8,4),sprite_59
		.db singleCoordinates(9,4),sprite_35
		
		.db singleCoordinates(1,5),sprite_23
		.db singleCoordinates(2,5),sprite_35
		.db singleCoordinates(3,5),sprite_25
		.db singleCoordinates(4,5),sprite_10
		.db singleCoordinates(5,5),sprite_10
		.db singleCoordinates(6,5),sprite_10
		.db singleCoordinates(7,5),sprite_10
		.db singleCoordinates(8,5),sprite_13
		.db singleCoordinates(9,5),sprite_23
		.db singleCoordinates(10,5),sprite_35
		
		.db singleCoordinates(1,6),sprite_47
		.db singleCoordinates(2,6),sprite_59
		.db singleCoordinates(9,6),sprite_47
		.db singleCoordinates(10,6),sprite_59
		
		.db singleCoordinates(1,7),sprite_25
		.db singleCoordinates(2,7),sprite_10
		.db singleCoordinates(3,7),sprite_10
		.db singleCoordinates(4,7),sprite_23
		.db singleCoordinates(5,7),sprite_49
		.db singleCoordinates(6,7),sprite_49
		.db singleCoordinates(7,7),sprite_35
		.db singleCoordinates(8,7),sprite_10
		.db singleCoordinates(9,7),sprite_10
		.db singleCoordinates(10,7),sprite_13
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,2),sprite_23
		.db singleCoordinates(4,2),sprite_35
		.db singleCoordinates(7,2),sprite_23
		.db singleCoordinates(8,2),sprite_35
		
		.db singleCoordinates(2,3),sprite_23
		.db singleCoordinates(3,3),sprite_47
		.db singleCoordinates(4,3),sprite_59
		.db singleCoordinates(7,3),sprite_47
		.db singleCoordinates(8,3),sprite_59
		.db singleCoordinates(9,3),sprite_35
		
		.db singleCoordinates(1,4),sprite_23
		.db singleCoordinates(2,4),sprite_35
		.db singleCoordinates(3,4),sprite_25
		.db singleCoordinates(4,4),sprite_10
		.db singleCoordinates(5,4),sprite_10
		.db singleCoordinates(6,4),sprite_10
		.db singleCoordinates(7,4),sprite_10
		.db singleCoordinates(8,4),sprite_13
		.db singleCoordinates(9,4),sprite_23
		.db singleCoordinates(10,4),sprite_35
		
		.db singleCoordinates(1,5),sprite_47
		.db singleCoordinates(2,5),sprite_59
		.db singleCoordinates(9,5),sprite_47
		.db singleCoordinates(10,5),sprite_59
		
		.db singleCoordinates(1,6),sprite_25
		.db singleCoordinates(2,6),sprite_10
		.db singleCoordinates(3,6),sprite_10
		.db singleCoordinates(4,6),sprite_23
		.db singleCoordinates(5,6),sprite_49
		.db singleCoordinates(6,6),sprite_49
		.db singleCoordinates(7,6),sprite_35
		.db singleCoordinates(8,6),sprite_10
		.db singleCoordinates(9,6),sprite_10
		.db singleCoordinates(10,6),sprite_13
		
		.db singleCoordinates(4,7),sprite_47
		.db singleCoordinates(5,7),sprite_83
		.db singleCoordinates(6,7),sprite_83
		.db singleCoordinates(7,7),sprite_59
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,1),sprite_23
		.db singleCoordinates(4,1),sprite_35
		.db singleCoordinates(7,1),sprite_23
		.db singleCoordinates(8,1),sprite_35
		
		.db singleCoordinates(2,2),sprite_23
		.db singleCoordinates(3,2),sprite_47
		.db singleCoordinates(4,2),sprite_59
		.db singleCoordinates(7,2),sprite_47
		.db singleCoordinates(8,2),sprite_59
		.db singleCoordinates(9,2),sprite_35
		
		.db singleCoordinates(1,3),sprite_23
		.db singleCoordinates(2,3),sprite_35
		.db singleCoordinates(3,3),sprite_25
		.db singleCoordinates(4,3),sprite_10
		.db singleCoordinates(5,3),sprite_10
		.db singleCoordinates(6,3),sprite_10
		.db singleCoordinates(7,3),sprite_10
		.db singleCoordinates(8,3),sprite_13
		.db singleCoordinates(9,3),sprite_23
		.db singleCoordinates(10,3),sprite_35
		
		.db singleCoordinates(1,4),sprite_47
		.db singleCoordinates(2,4),sprite_59
		.db singleCoordinates(9,4),sprite_47
		.db singleCoordinates(10,4),sprite_59
		
		.db singleCoordinates(1,5),sprite_25
		.db singleCoordinates(2,5),sprite_10
		.db singleCoordinates(3,5),sprite_10
		.db singleCoordinates(4,5),sprite_23
		.db singleCoordinates(5,5),sprite_49
		.db singleCoordinates(6,5),sprite_49
		.db singleCoordinates(7,5),sprite_35
		.db singleCoordinates(8,5),sprite_10
		.db singleCoordinates(9,5),sprite_10
		.db singleCoordinates(10,5),sprite_13
		
		.db singleCoordinates(4,6),sprite_47
		.db singleCoordinates(5,6),sprite_83
		.db singleCoordinates(6,6),sprite_83
		.db singleCoordinates(7,6),sprite_59
		
		.db singleCoordinates(4,7),sprite_263
		.db singleCoordinates(5,7),sprite_261
		.db singleCoordinates(6,7),sprite_261
		.db singleCoordinates(7,7),sprite_275
		.db $ff
	.db script_shake_screen
	
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_sandcastle_present_maze:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_664
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,1),sprite_blank
		.db singleCoordinates(10,1),sprite_171
		.db singleCoordinates(9,2),sprite_7
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,2),sprite_blank
		.db singleCoordinates(10,1),sprite_blank
		.db singleCoordinates(10,2),sprite_171
		.db singleCoordinates(9,3),sprite_7
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(10,2),sprite_blank
		.db singleCoordinates(10,3),sprite_8
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(9,3),sprite_blank
		.db singleCoordinates(9,4),sprite_blank
		.db singleCoordinates(10,3),sprite_7
		.db singleCoordinates(10,4),sprite_42
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(10,3),sprite_blank
		.db singleCoordinates(10,4),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(11,3),sprite_blank
		.db singleCoordinates(11,4),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_sandcastle_present_trees:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_695
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_17
		.db singleCoordinates(7,4),sprite_blank
		.db singleCoordinates(7,5),sprite_6
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_29
		.db singleCoordinates(7,5),sprite_blank
		.db singleCoordinates(6,6),sprite_41
		.db singleCoordinates(7,6),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_sandcastle_present_rocks_1:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_705
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,4),sprite_260
		.db singleCoordinates(4,4),sprite_260
		.db singleCoordinates(5,4),sprite_264
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,5),sprite_265
		.db singleCoordinates(4,5),sprite_265
		.db singleCoordinates(5,5),sprite_265
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(3,6),sprite_266
		.db singleCoordinates(4,6),sprite_266
		.db singleCoordinates(5,6),sprite_266
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_stop

script_sandcastle_present_rocks_2:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_683
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(2,2),sprite_262
		.db singleCoordinates(3,3),sprite_282
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(1,2),sprite_blank
		.db singleCoordinates(2,3),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(1,3),sprite_blank
		.db singleCoordinates(3,4),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(2,4),sprite_blank
		.db $ff
	.db script_shake_screen
		
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	.db script_stop

script_sandcastle_present_rocks_3:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_fade_to_white
	.db script_load_map,tilemap_668
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(4,0),sprite_7
		.db singleCoordinates(5,0),sprite_9
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(4,0),sprite_271
		.db singleCoordinates(5,0),sprite_270
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(4,1),sprite_242
		.db singleCoordinates(5,1),sprite_243
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_fade_return_map
	.db script_shake_screen
	.db script_shake_screen
	.db script_stop

script_sandcastle_present_tower_bomb:
	.db script_shake_screen
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,5),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,6),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_overwrite_sprite
		.db singleCoordinates(5,6),sprite_blank
		.db $ff
	.db script_shake_screen
	
	.db script_shake_screen
	.db script_stop

script_sandcastle_past_chestgate:
	.db script_fade_to_white
	.db script_load_map,tilemap_574
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32
	
	.db script_stop

script_sandcastle_past_portalgate_1:
	.db script_fade_to_white
	.db script_load_map,tilemap_619
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32

	.db script_stop

script_sandcastle_past_portalgate_2:
	.db script_fade_to_white
	.db script_load_map,tilemap_603
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32

	.db script_stop

script_sandcastle_past_portalgate_3:
	.db script_fade_to_white
	.db script_load_map,tilemap_629
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32

	.db script_stop

script_sandcastle_past_portalgate_4:
	.db script_fade_to_white
	.db script_load_map,tilemap_628
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,32

	.db script_stop

script_sandcastle_past_forcefield:
	.db script_sleep,6
	.db script_fade_to_white
	.db script_load_map,tilemap_622
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,12
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,2),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,3),sprite_265
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_266
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,6),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_blank
		.db $ff
	.db script_sleep,6
	
	.db script_sleep,6
	.db script_fade_to_white
	.db script_load_map,tilemap_625
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,12
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,0),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,1),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,2),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,3),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,6),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_blank
		.db $ff
	.db script_sleep,6
	
	.db script_sleep,6
	.db script_fade_to_white
	.db script_load_map,tilemap_551
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,12
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,0),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,1),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,2),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,3),sprite_265
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_266
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,6),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_blank
		.db $ff
	.db script_sleep,6
	
	.db script_sleep,6
	.db script_fade_to_white
	.db script_load_map,tilemap_549
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,12
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,0),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,1),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,2),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,3),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,6),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,7),sprite_blank
		.db $ff
	.db script_sleep,6
	
	
	.db script_sleep,6
	.db script_fade_to_white
	.db script_load_map,tilemap_539
	.db script_draw_tilemap
	.db script_fade_from_white
	.db script_sleep,12
	
	.db script_overwrite_sprite
		.db singleCoordinates(6,0),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,1),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,2),sprite_blank
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,3),sprite_265
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,4),sprite_266
		.db $ff
	.db script_sleep,6
	.db script_overwrite_sprite
		.db singleCoordinates(6,5),sprite_blank
		.db $ff
	.db script_sleep,6
	
	.db script_sleep,32
	.db script_fade_return_map
	.db script_stop
