SpeechMove:
	; we basically call this thing with call SpeechMove \ .dw address
	; so we need to modify the return address while fetching the hl pointer
	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	ex de,hl
_SpeechMove_entry:
	ld a,c
	sub 25
	jr nc,{+1@}
		xor a
		jr {+2@}
	@:
		ld a,1
	@:
Speech:
; hl - speech pointer
; a - 1:top, 0:bottom ; 2nd bit: 0:reuben or 1:update?
	push bc
	push af
		ld a,$40     ; make sure screen isn't rotated
		out ($10),a
		call Wait_Key_Release
	_Speech_Loop:
	pop af
	push af
		bit 0,a
		jr nz,{+1@} ; we want bottom
			ld ix,frontBuffer1+(12*(64-24))
			ld iy,frontBuffer2+(12*(64-24))
		jr {+2@}
		@:
			ld ix,frontBuffer1
			ld iy,frontBuffer2
		@:
		ld bc,12*24
		@:
			xor a
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			dec bc
			xor a
			or b
			or c
			jr nz,{-1@}
		
	pop af
	push af
		bit 0,a
		jr nz,{+1@} ; we only need to change stuff on bottom
			ld ix,frontBuffer1+(12*(64-25))
			ld iy,frontBuffer2+(12*(64-25))
		@:
		ld b,12
		ld a,$FF
		@:
			ld (ix),a
			ld (iy),a
			inc ix
			inc iy
			djnz {-1@}
		
	pop af
	push af
		bit 0,a
		jr nz,{+1@}
			ld bc,$0029
		jr {+2@}
		@:
			ld bc,$0000
		@:
		ld a,2
		bit 7,h ; if hl is in ram that means we already ran once, thus we need to continue
		jr z,{+1@}
		bcall(_Text_continue)
		jr {+2@}
	@:	bcall(_Text)
	@:	or a
		jr z,_Speech_Exit
		ld b,a
	pop af
	push af
		bit 0,a
		jr nz,{+1@}
			ld ix,frontBuffer1+(60*12)+11
			jr {+2@}
		@:
			ld ix,frontBuffer1+(20*12)+11
		@:
		ld a,b
		ld de,12
		cp $fe
		jr nz,{+1@} ;  \r, arrow down
			ld a,(ix)
			or %01111110
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00111100
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00011000
			ld (ix),a
		jr {+2@}
		@:          ; \b, quit thingy
			cp $fc
			jr z,_Speech_Ask
			ld a,(ix)
			or %00111100
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %01111110
			ld (ix),a
			add ix,de
			ld a,(ix)
			or %00111100
			ld (ix),a
		@:
		
		call Wait_Key_Release
		call Wait_Key_Input
		call Wait_Key_Release
		
		jp _Speech_Loop
_Speech_Exit:
	push de ; we want to preserve e as that is the reply of a pick thingy
	call Update
	pop de
	pop af
	
	pop bc
	bit 1,a
	ret nz
	push de
		call _Move_Draw_Reuben
	pop de
	ret
_Speech_Ask:
	bcall(_Speech_Ask_Textpage)
	jr _Speech_Exit
	
