Start:
	bcall(_memchk)
	or a
	ld de,ReubenDefaultDataLen + 14
	sbc hl,de
	jr nc,{+1@}
		ld hl,0
		ld (curRow),hl
		ld hl,notEnoughRam
		ld de,SaveSScreen
		ld bc,notEnoughRamLen
		ldir
		bcall(_delres)
		bcall(_ClrLCDFull)
		bcall(_HomeUP)
		ld hl,SaveSScreen
		bcall(_putS)
		bcall(_Newline)
		bcall(_putS)
		bcall(_getKey)
		bcall(_JForceCmdNoChar)
	@:

	di ; turn off interrupts

	ld hl,StatVars+531
	ld de,textShadow
	ld bc,128-4
	ldir

	ld hl,StatVars+531+128-4
	ld de,textShadPtrs
	ld bc,5
	ldir

	ld hl,StatVars+531+128-4+5
	ld de,progCurrent
	ld bc,108
	ldir

	;clear the screen
	bcall(_ClrAllBuffers)



	; set up the jump handler
	ld hl,$8585
	ld (hl),$c3 ; jp
	;ld de,keyToStr ; that is where it will be
	inc hl
	ld (hl),$76
	inc hl
	ld (hl),$9D

	;copy the interrupt loader
	ld hl,LoadInterrupt
	ld de,keyToStr
	ld bc,LoadInterruptSize
	ldir
	ld a,(basepage)
	sub :Interrupt
	ld (LoadInterrupt_page),a

	;copy apack_decompress
	ld hl,apack_decompress_real
	ld de,apack_decompress
	ld bc,apack_end-apack_decompress_real
	ldir

	ld hl,interruptMask
	ld (hl),%00001000


	in a,(2) ; test for crystal timer support
	bit 7,a
	jr nz,{+1@}
		; we need to fall back
		set 1,(hl)
	@:
	ld a,(hl) ; activate interrupts
	out (3),a
	
	
	
	call RestoreScreenSettings
	
	ld a,$80 ; this is where the vector table is
	ld i,a
	
	
	call loadInterruptSettings
	
	call DisableInterrupts
	
	; load appvar
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	jr c,_Run_No_AppVar
	
	ld a,b
	or a
	jr nz,_Run_AppVar_in_Flash
	jr _Run_AppVar_in_RAM
_Run_No_AppVar:
	ld hl,AppVarName ; create the appvar
	rst rMov9ToOP1
	ld hl,ReubenDefaultDataLen
	bcall(_CreateAppVar)
	inc de ; header
	inc de
	ld hl,ReubenDefaultData
	ld bc,ReubenDefaultDataLen
	ldir
	
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	
_Run_AppVar_in_RAM:
	ld hl,AppVarName
	rst rMov9ToOP1
	bcall(_Arc_Unarc)
_Run_AppVar_in_Flash:
	; no need to ei etc as that does the Load
	call RestoreInterrupts
	
	
	
	
	ld a,%10111110 ; listen to key groups
	out (1),a
	
	
	xor a
	ld (tmpMap),a
	ld (battle_flags),a
	
	jp RestoreScreenSettings

Stop:
	call DisableInterrupts

	; make sure we are in the correct screen mode
	ld    a,$05
	out   ($10),a


	ld a,%00001011 ; disable custom interrupt stuff
	out (3),a


	; restore os contrast
	ld a,(contrast)
	add a,$D8
	out ($10),a


	ld hl,textShadow
	ld de,StatVars+531
	ld bc,128-4
	ldir

	ld hl,textShadPtrs
	ld de,StatVars+531+128-4
	ld bc,5
	ldir

	ld hl,progCurrent
	ld de,StatVars+531+128-4+5
	ld bc,108
	ldir

	ld hl,listEditPtrs
	ld (hl),0
	ld de,listEditPtrs+1
	ld bc,121+48-1
	ldir
	
	ld iy,flags ; restore iy

	bcall(_DelRes) ; make sure we don't have the coordinates bug anymore
	bcall(_clrTxtShd)
	bcall(_fillBasePageTable)
	bcall(_grReset)

	bcall(_JForceCmdNoChar)		 ; Exit

	
RestoreScreenSettings:
	@:
		in a,($10)
		bit 7,a
		jr nz,{-1@}
	ld    a,$07
	out   ($10),a		     ; set LCD to increase mode
	@:
		in a,($10)
		bit 7,a
		jr nz,{-1@}
	ld a,$01
	out ($10),a ; set to 8 bit mode
	ret


UpdateWalkableTiles:
	isEvent_real(event_can_swim_offset,event_can_swim_bit)
	jr nz,{+}
		ld a,sprite_after_walk
		ld (walkableTiles),a
		ret
	+:
	ld a,sprite_after_swim
	ld (walkableTiles),a
	ret

Load:
	call DisableInterrupts
	ld hl,AppVarName                         ; load appvar into reuben
	rst rMov9ToOP1
	bcall(_ChkFindSym)
	ex de,hl
	
	ld a,1+2+7+AppVarNameLen+2
	@:
		bcall(_LoadDEIndPaged)
		dec a
		jr nz,{-1@}
	ld a,b
	
	ld bc,ReubenDefaultDataLen
	ld de,reuben
	bcall(_FlashToRAM)
	
	call RestoreScreenSettings
	call RestoreInterrupts
	bcall(_SetBattleCounter)
	ld a,2
	ld (moveDirection),a
	ld a,(reuben_map)
	ld (TileMapData),a
	jp UpdateWalkableTiles

Save:
	call DisableInterrupts
	
		ld iy,flags
		
		;ld hl,AppVarName
		;rst rMov9ToOP1
		;bcall(_ChkFindSym)
		
		ld hl,AppVarName     ; appvar is in ram now
		rst rMov9ToOP1
		bcall(_Arc_Unarc)
		
		ld hl,AppVarName
		rst rMov9ToOP1
		bcall(_ChkFindSym)
		
		inc de  ; header
		inc de
		ld hl,reuben
		ld bc,ReubenDefaultDataLen
		ldir
		
		ld hl,AppVarName     ; appvar is in archive now
		rst rMov9ToOP1
		bcall(_Arc_Unarc)
		call RestoreScreenSettings
		
		ld a,(reuben_map)   ; somehow the tilemap gets destroyed
		ld (TileMapData),a
		bcall(_LoadTileMap)
		bcall(_DrawTileMap)
	
	bcall(_Update)
	call RestoreInterrupts
	ld a,%10111110 ; listen to key groups
	out (1),a
	ret


ResetGameData:
	ld hl,ReubenDefaultData
	ld de,reuben
	ld bc,ReubenDefaultDataLen
	ldir
	ret



ReubenDefaultData: ; note to self: little endian
	.db $01 ; lvl
	.dw 120 ; hp
	.db $00,$00 ; exp
	.db $17 ; mp
	.dw 120 ; max hp
	.dw 5 ; next exp
	.db $17 ; max mp
	.db $00,$00 ; gold
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0 ; bottles and events
	.db 0,0,0,0,0
	.db 0,0,0
	.db tilemap_37 ; map
	.db 64 ; x-pos
	.db 24 ; y-pos
	.dw 100 ; max gold
	.db $01 ; armor
	.db $FF ; wait
	.db 0   ; sword
	.db 0   ; curitem
	.db world_overworld   ; default world
	.db 0   ; trade quest
	.db 0   ; fright
	.db 10  ; num bombs
	.db 10  ; max bombs
	.db 0   ; tilemap_pos_id
ReubenDefaultDataLen = $-ReubenDefaultData


notEnoughRam:
	.asc "Not enough RAM",0
	.asc "*Press any key*",0
notEnoughRamLen = $ - notEnoughRam


AppVarName:
	.db AppVarObj,"R3Sav",0
AppVarNameLen = $ - AppVarName - 2
