Text:
;INPUT: b=xpos
;;c=ypos
;;hl = text
;;a = (0 - big, 1 - small), char-by-char(2 - big, 3 - small)
;OUTPUT: a=char
;bc=pos
;hl=pointer
;Destroys: de,ix,iy
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push de
		ld e,(hl)
		call _Text_decompressloop
	pop de
	add hl,de
	
Text_continue:
	push af
	call Text_entry
	pop de
	cp $fb
	ret nz
	ld a,d
	ld hl,tmp5
	ld e,(hl)
	inc e
	call _Text_decompressloop
	jr Text_continue
_Text_decompressloop:
	push bc
	push af
	
	ld d,0
	ld a,e
	ld (tmp5),a
	
	ld hl,_Text_decompression_LUT
	add hl,de
	add hl,de
	push hl
		ld hl,decompressBackup
		ld de,decompressBackupArea
		ld bc,33
		ldir
	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	
	ld de,decompressArea
	
	cp first_offpage_textblock
	jr nc,{+}
		call apack_decompress
		ld a,($83EB)
		ld (decompressBackupByte),a
		
		ld hl,decompressBackup
		ld de,decompressBackupArea+33
		ld bc,33
		ldir
		
		
		ld hl,decompressBackupArea
		ld de,decompressBackup
		ld bc,33
		ldir
		jr {++}
	+:
		bcall(_Offpage_Text_Decompress)
	++:

	
	pop af
	pop bc
	ld hl,decompressArea
	ld de,0
	ret

Num1:
	ld	a,$01-1
Num2:
	inc	a
	add	hl,de
	jr	c,Num2
	sbc	hl,de
	dec c
	ret nz
	inc c
	push hl
	ld hl,(tmp4)
	ld (hl),a
	inc hl
	ld (tmp4),hl
	pop hl
	ret

NumText:
;INPUT hl = number

	push bc
	push af
		ld b,1
		
		push hl
			ld c,1
			ld de,10000
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,1000
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,100
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
			ld de,10
			or a
			sbc hl,de ; cp
			jr nc,{+1@}
			add hl,de
			inc c
		@:
			ld hl,textBuffer
			ld (tmp4),hl
		pop hl
		
		ld	de,-10000
		call	Num1
		ld	de,-1000
		call	Num1
		ld	de,-100
		call	Num1
		ld	e,-10
		call	Num1
		ld	e,-1
		call	Num1
		
		ld hl,(tmp4)
		ld (hl),0
		ld hl,textBuffer
	pop af
	pop bc

Text_entry:
	ld de,Chars ; add offset
	push af
		ld (tmp3),a
		ld a,7
		ld (tmp1),a
		dec a
		ld (tmp2),a
	pop af
	push bc
	bit 0,a
	jr z,_Text_Loop ; we use the big font!
		ld de,SmallChars ; time to use the small font
		ld a,5
		ld (tmp1),a
		dec a
		ld (tmp2),a
_Text_Loop:
	ld a,(tmp3)
	bit 1,a
	jr z,_Text_Skip_Key
		in a,(1)
		cp $FF
		jr c,_Text_Skip_Key
		ld a,4
		bcall(_Sleep)
_Text_Skip_Key:
	call _Text_fetch_byte
	or a
	jr z,_Text_end
	cp $fb
	jr c,{+1@}
		cp $ff ; one more as $fe still needs to trigger
		jr c,_Text_end
	@:
	push hl
	push bc
		dec a ; sprites start one earlier
		
		
		
		push de
			push bc
				cp $fe ; we subtracted one
				jr z,_Text_Loop_Line_Break
				
				ld h,0 ; a into hl and times tmp1
				ld l,a
				ld a,(tmp1)
				ld b,a
				bcall(_Multiply)
			pop bc
			
			
			
		pop de
		
		add hl,de
		
		push de
			ld a,(tmp1)
			ld e,a
			ld ix,frontBuffer1
			ld iy,frontBuffer2
			call BlackSpriteXOR ; this is actually on our page!
		pop de
	pop bc
	pop hl
	inc hl
	
	ld a,(tmp2)

	add a,b
	ld b,a
	jr _Text_Loop
_Text_Loop_Line_Break:
	
	pop bc
	pop de
	pop bc
	pop hl
	
	pop bc ; get original positions
	ld a,8
	add a,c
	ld c,a
	ld b,0
	push bc
	
	inc hl
	jp _Text_Loop
_Text_end:
	pop de ; we want to preserve bc and hl
	inc hl
	ret


Speech_Ask_Textpage:
	ld b,6
	ld a,2
	call Text_continue
	
	inc c
	
	call _Text_fetch_byte
	ld d,a ; in d is now the number of itmes
	inc hl
	ld e,0 ; e is the currently selected item
	
	_Speech_Ask_Textpage_loop:
		call _Speech_Ask_Textpage_drawhand
		bcall(_Wait_Key_Release)
		bcall(_Wait_Key_Input)
		call _Speech_Ask_Textpage_drawhand
		ld b,a
		bit 1,b ; left
		jr nz,{+1@}
			dec e
			inc e
			jr z,{+1@}
			dec e
		@:
		bit 2,b ; right
		jr nz,{+1@}
			inc e
			ld a,e
			cp d
			jr c,{+1@}
			dec e
		@:
		bit 5,b ; 2nd
		jr nz,_Speech_Ask_Textpage_loop
	
	bcall(_Wait_Key_Release)
	ret
_Speech_Ask_Textpage_drawhand:
	push af
	push de
	push hl
	push bc
		ld d,0
		add hl,de
		call _Text_fetch_byte
		ld b,a
		ld ix,frontBuffer1
		ld iy,frontBuffer2
		ld a,bigsprite_bulletpoint
		bcall(_PutBigSpriteXOR)
	pop bc
	pop hl
	pop de
	pop af
	ret


	
_Text_fetch_byte:
	bit 7,h
	jr nz,{+}
	ld a,(hl)
	ret
+:
	push bc
	push de
	push hl
		ld hl,decompressBackupArea+33
		ld de,decompressBackup
		ld bc,33
		ldir
		ld a,(decompressBackupByte)
		ld ($83EB),a
	pop hl
	pop de
	pop bc

	ld a,(hl)

	push bc
	push de
	push hl
		ld hl,decompressBackupArea
		ld de,decompressBackup
		ld bc,33
		ldir
	pop hl
	pop de
	pop bc
	ret

BlackSpriteXOR:
; bc - positions
; ix - buffer1
; iy - buffer2
; hl - sprite
; e - height
	push de
	push hl
		ld d,0
		ld e,c
		ld h,d
		ld l,e
		add hl,hl
		add hl,de
		add hl,hl
		add hl,hl
		ld e,b
		srl e
		srl e
		srl e
		add hl,de
		ex de,hl
		add ix,de
		add iy,de
	pop hl
	pop de
	ld a,b
	and 7
	ld b,e
	jr z,_BlackSpriteXORAligned
	ld c,a
	@:
		push bc
			ld b,c
			
			ld d,(hl)
			inc hl
			
			xor a
			_BlackSpriteXORLoop:  ; shifting: da - data
				srl d
				rra
				djnz _BlackSpriteXORLoop
			ld e,a
			ld a,(ix)
			xor d
			ld (ix),a
			
			ld a,(iy)
			xor d
			ld (iy),a
			
			ld a,(ix+1)
			xor e
			ld (ix+1),a
			
			ld a,(iy+1)
			xor e
			ld (iy+1),a
			
			ld de,12
			add ix,de
			add iy,de
		pop bc
		djnz {-1@}
	ret
_BlackSpriteXORAligned:
	ld de,12
	@:
		ld a,(ix)
		xor (hl)
		ld (ix),a
		
		ld a,(iy)
		xor (hl)
		ld (iy),a
		
		add ix,de
		add iy,de
		inc hl
		djnz {-1@}
	ret
