Titlescreen:
	ld hl,_Titlescreen_Buffer1
	ld de,backBuffer1
	call apack_decompress
	ld hl,_Titlescreen_Buffer2
	ld de,backBuffer2
	call apack_decompress
	bcall(_Update)
	bcall(_Wait_Key_Release)
	bcall(_Wait_Key_Input)
	bcall(_Wait_Key_Release)
	
	ld hl,backBuffer1 + (64-13)*12
	ld de,backBuffer2 + (64-13)*12
	ld a,$ff
	ld b,12*2
	-:
		ld (hl),a
		inc hl
		ex de,hl
		djnz {-}
	xor a
	ld b,12*12
	-:
		ld (hl),a
		inc hl
		ex de,hl
		ld (hl),a
		inc hl
		ex de,hl
		djnz {-}
	bcall(_Update)
	ld bc,getCoordinates(1,64 - 10)
	xor a
	ld hl,string_arrow_left
	bcall(_Text_entry)
	ld bc,getCoordinates(96 - 6,64 - 10)
	xor a
	ld hl,string_arrow_right
	bcall(_Text_entry)
	bcall(_RevUpdate)
	
	ld b,1
	isEvent_real(event_game_started_offset,event_game_started_bit)
	jr nz,_Titlescreen_Loop
	inc b ; default to "new game" (which is actually in this case the same as continue)
_Titlescreen_Loop:
	push bc
		bcall(_Update)
	pop bc
	push bc
		ld a,b
		add a,b
		add a,b
		ld e,a
		ld d,0
		ld hl,_Titlescreen_Menu_LUT - 3
		add hl,de
		
		ld a,(hl)
		inc hl
		ld b,a
		ld c,64 - 10
		ld e,(hl)
		inc hl
		ld d,(hl)
		ex de,hl
		
		xor a
		bcall(_Text_entry)
	pop bc
	bcall(_Wait_Key_Input)
	bcall(_Wait_Key_Release)
	bit 7,a
	jr nz,{+}
		bcall(_Stop)
	+:
	bit 1,a ; left
	jr nz,{+}
		dec b
		jr nz,{+}
		ld b,5
	+:
	bit 2,a ; right
	jr nz,{+}
		inc b
		ld c,a
		ld a,b
		cp 6
		jr nz,{++}
			ld b,1
		++:
		ld a,c
	+:
	bit 5,a ; 2nd
	jr nz,_Titlescreen_Loop
	dec b
	ret z ; continue
	dec b
	jr nz,{+}
		; new game
		bcall(_ResetGameData)
		ret
	+:
	dec b
	jr nz,{+}
		; graphics
		bcall(_GrayTuner)
		jp Titlescreen
	+:
	dec b
	jr nz,{+}
		; credits
		bcall(_Credits)
		jp Titlescreen
	+:
	bcall(_Stop)
_Titlescreen_Menu_LUT:
	.db (96/2) - (8*3)
	.dw string_titlescreen_continue
	
	.db (96/2) - (8*3)
	.dw string_titlescreen_new_game
	
	.db (96/2) - (8*3)
	.dw string_titlescreen_graphics
	
	.db (96/2) - (7*3)
	.dw string_titlescreen_credits
	
	.db (96/2) - (4*3)
	.dw string_titlescreen_exit
_Titlescreen_Buffer1:
	.incbin titlescreen_buffer1.bin
_Titlescreen_Buffer2:
	.incbin titlescreen_buffer2.bin
